{-# OPTIONS -Wall #-}

> ------------------------------------------------------------------------------
> -- | 
> -- Module       :   Wumpus.Core.Text.GlyphNames
> -- Copyright    :   (c) Stephen Tetley 2010
> -- License      :   BSD3
> -- 
> -- Maintainer   :   Stephen Tetley <stephen.tetley@gmail.com>
> -- Stability    :   unstable
> -- Portability  :   GHC
> -- 
> -- Map of Unicode code points to PostScript glyph names.
> -- 
> -- \*\* This file is auto-generated. \*\*
> -- 
> -- Generated - 2010-11-13 15:30
> -- 
> ------------------------------------------------------------------------------

> module Wumpus.Core.Text.GlyphNames
>   (
>      ps_glyph_names
>   ) where

> import Data.IntMap ( IntMap, fromAscList )

> -- | Index table mapping from Unicode code point to the
> -- corresponding PostScript name defined by the Adobe
> -- glyphlist.

> ps_glyph_names :: IntMap String
> ps_glyph_names = fromAscList $
>     [ ( 0x0001, "controlSTX" )
>     , ( 0x0002, "controlSOT" )
>     , ( 0x0003, "controlETX" )
>     , ( 0x0004, "controlEOT" )
>     , ( 0x0005, "controlENQ" )
>     , ( 0x0006, "controlACK" )
>     , ( 0x0007, "controlBEL" )
>     , ( 0x0008, "controlBS" )
>     , ( 0x0009, "controlHT" )
>     , ( 0x000a, "controlLF" )
>     , ( 0x000b, "controlVT" )
>     , ( 0x000c, "controlFF" )
>     , ( 0x000d, "controlCR" )
>     , ( 0x000e, "controlSO" )
>     , ( 0x000f, "controlSI" )
>     , ( 0x0010, "controlDLE" )
>     , ( 0x0011, "controlDC1" )
>     , ( 0x0012, "controlDC2" )
>     , ( 0x0013, "controlDC3" )
>     , ( 0x0014, "controlDC4" )
>     , ( 0x0015, "controlNAK" )
>     , ( 0x0016, "controlSYN" )
>     , ( 0x0017, "controlETB" )
>     , ( 0x0018, "controlCAN" )
>     , ( 0x0019, "controlEM" )
>     , ( 0x001a, "controlSUB" )
>     , ( 0x001b, "controlESC" )
>     , ( 0x001c, "controlFS" )
>     , ( 0x001d, "controlGS" )
>     , ( 0x001e, "controlRS" )
>     , ( 0x001f, "controlUS" )
>     , ( 0x0020, "space" )
>     , ( 0x0021, "exclam" )
>     , ( 0x0022, "quotedbl" )
>     , ( 0x0023, "numbersign" )
>     , ( 0x0024, "dollar" )
>     , ( 0x0025, "percent" )
>     , ( 0x0026, "ampersand" )
>     , ( 0x0027, "quotesingle" )
>     , ( 0x0028, "parenleft" )
>     , ( 0x0029, "parenright" )
>     , ( 0x002a, "asterisk" )
>     , ( 0x002b, "plus" )
>     , ( 0x002c, "comma" )
>     , ( 0x002d, "hyphen" )
>     , ( 0x002e, "period" )
>     , ( 0x002f, "slash" )
>     , ( 0x0030, "zero" )
>     , ( 0x0031, "one" )
>     , ( 0x0032, "two" )
>     , ( 0x0033, "three" )
>     , ( 0x0034, "four" )
>     , ( 0x0035, "five" )
>     , ( 0x0036, "six" )
>     , ( 0x0037, "seven" )
>     , ( 0x0038, "eight" )
>     , ( 0x0039, "nine" )
>     , ( 0x003a, "colon" )
>     , ( 0x003b, "semicolon" )
>     , ( 0x003c, "less" )
>     , ( 0x003d, "equal" )
>     , ( 0x003e, "greater" )
>     , ( 0x003f, "question" )
>     , ( 0x0040, "at" )
>     , ( 0x0041, "A" )
>     , ( 0x0042, "B" )
>     , ( 0x0043, "C" )
>     , ( 0x0044, "D" )
>     , ( 0x0045, "E" )
>     , ( 0x0046, "F" )
>     , ( 0x0047, "G" )
>     , ( 0x0048, "H" )
>     , ( 0x0049, "I" )
>     , ( 0x004a, "J" )
>     , ( 0x004b, "K" )
>     , ( 0x004c, "L" )
>     , ( 0x004d, "M" )
>     , ( 0x004e, "N" )
>     , ( 0x004f, "O" )
>     , ( 0x0050, "P" )
>     , ( 0x0051, "Q" )
>     , ( 0x0052, "R" )
>     , ( 0x0053, "S" )
>     , ( 0x0054, "T" )
>     , ( 0x0055, "U" )
>     , ( 0x0056, "V" )
>     , ( 0x0057, "W" )
>     , ( 0x0058, "X" )
>     , ( 0x0059, "Y" )
>     , ( 0x005a, "Z" )
>     , ( 0x005b, "bracketleft" )
>     , ( 0x005c, "backslash" )
>     , ( 0x005d, "bracketright" )
>     , ( 0x005e, "asciicircum" )
>     , ( 0x005f, "underscore" )
>     , ( 0x0060, "grave" )
>     , ( 0x0061, "a" )
>     , ( 0x0062, "b" )
>     , ( 0x0063, "c" )
>     , ( 0x0064, "d" )
>     , ( 0x0065, "e" )
>     , ( 0x0066, "f" )
>     , ( 0x0067, "g" )
>     , ( 0x0068, "h" )
>     , ( 0x0069, "i" )
>     , ( 0x006a, "j" )
>     , ( 0x006b, "k" )
>     , ( 0x006c, "l" )
>     , ( 0x006d, "m" )
>     , ( 0x006e, "n" )
>     , ( 0x006f, "o" )
>     , ( 0x0070, "p" )
>     , ( 0x0071, "q" )
>     , ( 0x0072, "r" )
>     , ( 0x0073, "s" )
>     , ( 0x0074, "t" )
>     , ( 0x0075, "u" )
>     , ( 0x0076, "v" )
>     , ( 0x0077, "w" )
>     , ( 0x0078, "x" )
>     , ( 0x0079, "y" )
>     , ( 0x007a, "z" )
>     , ( 0x007b, "braceleft" )
>     , ( 0x007c, "bar" )
>     , ( 0x007d, "braceright" )
>     , ( 0x007e, "asciitilde" )
>     , ( 0x007f, "controlDEL" )
>     , ( 0x00a0, "nbspace" )
>     , ( 0x00a1, "exclamdown" )
>     , ( 0x00a2, "cent" )
>     , ( 0x00a3, "sterling" )
>     , ( 0x00a4, "currency" )
>     , ( 0x00a5, "yen" )
>     , ( 0x00a6, "brokenbar" )
>     , ( 0x00a7, "section" )
>     , ( 0x00a8, "dieresis" )
>     , ( 0x00a9, "copyright" )
>     , ( 0x00aa, "ordfeminine" )
>     , ( 0x00ab, "guillemotleft" )
>     , ( 0x00ac, "logicalnot" )
>     , ( 0x00ad, "sfthyphen" )
>     , ( 0x00ae, "registered" )
>     , ( 0x00af, "macron" )
>     , ( 0x00b0, "degree" )
>     , ( 0x00b1, "plusminus" )
>     , ( 0x00b2, "twosuperior" )
>     , ( 0x00b3, "threesuperior" )
>     , ( 0x00b4, "acute" )
>     , ( 0x00b5, "mu" )
>     , ( 0x00b6, "paragraph" )
>     , ( 0x00b7, "middot" )
>     , ( 0x00b8, "cedilla" )
>     , ( 0x00b9, "onesuperior" )
>     , ( 0x00ba, "ordmasculine" )
>     , ( 0x00bb, "guillemotright" )
>     , ( 0x00bc, "onequarter" )
>     , ( 0x00bd, "onehalf" )
>     , ( 0x00be, "threequarters" )
>     , ( 0x00bf, "questiondown" )
>     , ( 0x00c0, "Agrave" )
>     , ( 0x00c1, "Aacute" )
>     , ( 0x00c2, "Acircumflex" )
>     , ( 0x00c3, "Atilde" )
>     , ( 0x00c4, "Adieresis" )
>     , ( 0x00c5, "Aring" )
>     , ( 0x00c6, "AE" )
>     , ( 0x00c7, "Ccedilla" )
>     , ( 0x00c8, "Egrave" )
>     , ( 0x00c9, "Eacute" )
>     , ( 0x00ca, "Ecircumflex" )
>     , ( 0x00cb, "Edieresis" )
>     , ( 0x00cc, "Igrave" )
>     , ( 0x00cd, "Iacute" )
>     , ( 0x00ce, "Icircumflex" )
>     , ( 0x00cf, "Idieresis" )
>     , ( 0x00d0, "Eth" )
>     , ( 0x00d1, "Ntilde" )
>     , ( 0x00d2, "Ograve" )
>     , ( 0x00d3, "Oacute" )
>     , ( 0x00d4, "Ocircumflex" )
>     , ( 0x00d5, "Otilde" )
>     , ( 0x00d6, "Odieresis" )
>     , ( 0x00d7, "multiply" )
>     , ( 0x00d8, "Oslash" )
>     , ( 0x00d9, "Ugrave" )
>     , ( 0x00da, "Uacute" )
>     , ( 0x00db, "Ucircumflex" )
>     , ( 0x00dc, "Udieresis" )
>     , ( 0x00dd, "Yacute" )
>     , ( 0x00de, "Thorn" )
>     , ( 0x00df, "germandbls" )
>     , ( 0x00e0, "agrave" )
>     , ( 0x00e1, "aacute" )
>     , ( 0x00e2, "acircumflex" )
>     , ( 0x00e3, "atilde" )
>     , ( 0x00e4, "adieresis" )
>     , ( 0x00e5, "aring" )
>     , ( 0x00e6, "ae" )
>     , ( 0x00e7, "ccedilla" )
>     , ( 0x00e8, "egrave" )
>     , ( 0x00e9, "eacute" )
>     , ( 0x00ea, "ecircumflex" )
>     , ( 0x00eb, "edieresis" )
>     , ( 0x00ec, "igrave" )
>     , ( 0x00ed, "iacute" )
>     , ( 0x00ee, "icircumflex" )
>     , ( 0x00ef, "idieresis" )
>     , ( 0x00f0, "eth" )
>     , ( 0x00f1, "ntilde" )
>     , ( 0x00f2, "ograve" )
>     , ( 0x00f3, "oacute" )
>     , ( 0x00f4, "ocircumflex" )
>     , ( 0x00f5, "otilde" )
>     , ( 0x00f6, "odieresis" )
>     , ( 0x00f7, "divide" )
>     , ( 0x00f8, "oslash" )
>     , ( 0x00f9, "ugrave" )
>     , ( 0x00fa, "uacute" )
>     , ( 0x00fb, "ucircumflex" )
>     , ( 0x00fc, "udieresis" )
>     , ( 0x00fd, "yacute" )
>     , ( 0x00fe, "thorn" )
>     , ( 0x00ff, "ydieresis" )
>     , ( 0x0100, "Amacron" )
>     , ( 0x0101, "amacron" )
>     , ( 0x0102, "Abreve" )
>     , ( 0x0103, "abreve" )
>     , ( 0x0104, "Aogonek" )
>     , ( 0x0105, "aogonek" )
>     , ( 0x0106, "Cacute" )
>     , ( 0x0107, "cacute" )
>     , ( 0x0108, "Ccircumflex" )
>     , ( 0x0109, "ccircumflex" )
>     , ( 0x010a, "Cdot" )
>     , ( 0x010b, "cdot" )
>     , ( 0x010c, "Ccaron" )
>     , ( 0x010d, "ccaron" )
>     , ( 0x010e, "Dcaron" )
>     , ( 0x010f, "dcaron" )
>     , ( 0x0110, "Dcroat" )
>     , ( 0x0111, "dcroat" )
>     , ( 0x0112, "Emacron" )
>     , ( 0x0113, "emacron" )
>     , ( 0x0114, "Ebreve" )
>     , ( 0x0115, "ebreve" )
>     , ( 0x0116, "Edot" )
>     , ( 0x0117, "edot" )
>     , ( 0x0118, "Eogonek" )
>     , ( 0x0119, "eogonek" )
>     , ( 0x011a, "Ecaron" )
>     , ( 0x011b, "ecaron" )
>     , ( 0x011c, "Gcircumflex" )
>     , ( 0x011d, "gcircumflex" )
>     , ( 0x011e, "Gbreve" )
>     , ( 0x011f, "gbreve" )
>     , ( 0x0120, "Gdot" )
>     , ( 0x0121, "gdot" )
>     , ( 0x0122, "Gcedilla" )
>     , ( 0x0123, "gcedilla" )
>     , ( 0x0124, "Hcircumflex" )
>     , ( 0x0125, "hcircumflex" )
>     , ( 0x0126, "Hbar" )
>     , ( 0x0127, "hbar" )
>     , ( 0x0128, "Itilde" )
>     , ( 0x0129, "itilde" )
>     , ( 0x012a, "Imacron" )
>     , ( 0x012b, "imacron" )
>     , ( 0x012c, "Ibreve" )
>     , ( 0x012d, "ibreve" )
>     , ( 0x012e, "Iogonek" )
>     , ( 0x012f, "iogonek" )
>     , ( 0x0130, "Idot" )
>     , ( 0x0131, "dotlessi" )
>     , ( 0x0132, "IJ" )
>     , ( 0x0133, "ij" )
>     , ( 0x0134, "Jcircumflex" )
>     , ( 0x0135, "jcircumflex" )
>     , ( 0x0136, "Kcedilla" )
>     , ( 0x0137, "kcedilla" )
>     , ( 0x0138, "kgreenlandic" )
>     , ( 0x0139, "Lacute" )
>     , ( 0x013a, "lacute" )
>     , ( 0x013b, "Lcedilla" )
>     , ( 0x013c, "lcedilla" )
>     , ( 0x013d, "Lcaron" )
>     , ( 0x013e, "lcaron" )
>     , ( 0x013f, "Ldot" )
>     , ( 0x0140, "ldot" )
>     , ( 0x0141, "Lslash" )
>     , ( 0x0142, "lslash" )
>     , ( 0x0143, "Nacute" )
>     , ( 0x0144, "nacute" )
>     , ( 0x0145, "Ncedilla" )
>     , ( 0x0146, "ncedilla" )
>     , ( 0x0147, "Ncaron" )
>     , ( 0x0148, "ncaron" )
>     , ( 0x0149, "napostrophe" )
>     , ( 0x014a, "Eng" )
>     , ( 0x014b, "eng" )
>     , ( 0x014c, "Omacron" )
>     , ( 0x014d, "omacron" )
>     , ( 0x014e, "Obreve" )
>     , ( 0x014f, "obreve" )
>     , ( 0x0150, "Odblacute" )
>     , ( 0x0151, "odblacute" )
>     , ( 0x0152, "OE" )
>     , ( 0x0153, "oe" )
>     , ( 0x0154, "Racute" )
>     , ( 0x0155, "racute" )
>     , ( 0x0156, "Rcedilla" )
>     , ( 0x0157, "rcedilla" )
>     , ( 0x0158, "Rcaron" )
>     , ( 0x0159, "rcaron" )
>     , ( 0x015a, "Sacute" )
>     , ( 0x015b, "sacute" )
>     , ( 0x015c, "Scircumflex" )
>     , ( 0x015d, "scircumflex" )
>     , ( 0x015e, "Scedilla" )
>     , ( 0x015f, "scedilla" )
>     , ( 0x0160, "Scaron" )
>     , ( 0x0161, "scaron" )
>     , ( 0x0162, "Tcedilla" )
>     , ( 0x0163, "tcedilla" )
>     , ( 0x0164, "Tcaron" )
>     , ( 0x0165, "tcaron" )
>     , ( 0x0166, "Tbar" )
>     , ( 0x0167, "tbar" )
>     , ( 0x0168, "Utilde" )
>     , ( 0x0169, "utilde" )
>     , ( 0x016a, "Umacron" )
>     , ( 0x016b, "umacron" )
>     , ( 0x016c, "Ubreve" )
>     , ( 0x016d, "ubreve" )
>     , ( 0x016e, "Uring" )
>     , ( 0x016f, "uring" )
>     , ( 0x0170, "Udblacute" )
>     , ( 0x0171, "udblacute" )
>     , ( 0x0172, "Uogonek" )
>     , ( 0x0173, "uogonek" )
>     , ( 0x0174, "Wcircumflex" )
>     , ( 0x0175, "wcircumflex" )
>     , ( 0x0176, "Ycircumflex" )
>     , ( 0x0177, "ycircumflex" )
>     , ( 0x0178, "Ydieresis" )
>     , ( 0x0179, "Zacute" )
>     , ( 0x017a, "zacute" )
>     , ( 0x017b, "Zdot" )
>     , ( 0x017c, "zdot" )
>     , ( 0x017d, "Zcaron" )
>     , ( 0x017e, "zcaron" )
>     , ( 0x017f, "longs" )
>     , ( 0x0180, "bstroke" )
>     , ( 0x0181, "Bhook" )
>     , ( 0x0182, "Btopbar" )
>     , ( 0x0183, "btopbar" )
>     , ( 0x0184, "Tonesix" )
>     , ( 0x0185, "tonesix" )
>     , ( 0x0186, "Oopen" )
>     , ( 0x0187, "Chook" )
>     , ( 0x0188, "chook" )
>     , ( 0x0189, "Dafrican" )
>     , ( 0x018a, "Dhook" )
>     , ( 0x018b, "Dtopbar" )
>     , ( 0x018c, "dtopbar" )
>     , ( 0x018d, "deltaturned" )
>     , ( 0x018e, "Ereversed" )
>     , ( 0x018f, "Schwa" )
>     , ( 0x0190, "Eopen" )
>     , ( 0x0191, "Fhook" )
>     , ( 0x0192, "florin" )
>     , ( 0x0193, "Ghook" )
>     , ( 0x0194, "Gammaafrican" )
>     , ( 0x0195, "hv" )
>     , ( 0x0196, "Iotaafrican" )
>     , ( 0x0197, "Istroke" )
>     , ( 0x0198, "Khook" )
>     , ( 0x0199, "khook" )
>     , ( 0x019a, "lbar" )
>     , ( 0x019b, "lambdastroke" )
>     , ( 0x019c, "Mturned" )
>     , ( 0x019d, "Nhookleft" )
>     , ( 0x019e, "nlegrightlong" )
>     , ( 0x019f, "Ocenteredtilde" )
>     , ( 0x01a0, "Ohorn" )
>     , ( 0x01a1, "ohorn" )
>     , ( 0x01a2, "Oi" )
>     , ( 0x01a3, "oi" )
>     , ( 0x01a4, "Phook" )
>     , ( 0x01a5, "phook" )
>     , ( 0x01a6, "yr" )
>     , ( 0x01a7, "Tonetwo" )
>     , ( 0x01a8, "tonetwo" )
>     , ( 0x01a9, "Esh" )
>     , ( 0x01aa, "eshreversedloop" )
>     , ( 0x01ab, "tpalatalhook" )
>     , ( 0x01ac, "Thook" )
>     , ( 0x01ad, "thook" )
>     , ( 0x01ae, "Tretroflexhook" )
>     , ( 0x01af, "Uhorn" )
>     , ( 0x01b0, "uhorn" )
>     , ( 0x01b1, "Upsilonafrican" )
>     , ( 0x01b2, "Vhook" )
>     , ( 0x01b3, "Yhook" )
>     , ( 0x01b4, "yhook" )
>     , ( 0x01b5, "Zstroke" )
>     , ( 0x01b6, "zstroke" )
>     , ( 0x01b7, "Ezh" )
>     , ( 0x01b8, "Ezhreversed" )
>     , ( 0x01b9, "ezhreversed" )
>     , ( 0x01ba, "ezhtail" )
>     , ( 0x01bb, "twostroke" )
>     , ( 0x01bc, "Tonefive" )
>     , ( 0x01bd, "tonefive" )
>     , ( 0x01be, "glottalinvertedstroke" )
>     , ( 0x01bf, "wynn" )
>     , ( 0x01c0, "clickdental" )
>     , ( 0x01c1, "clicklateral" )
>     , ( 0x01c2, "clickalveolar" )
>     , ( 0x01c3, "clickretroflex" )
>     , ( 0x01c4, "DZcaron" )
>     , ( 0x01c5, "Dzcaron" )
>     , ( 0x01c6, "dzcaron" )
>     , ( 0x01c7, "LJ" )
>     , ( 0x01c8, "Lj" )
>     , ( 0x01c9, "lj" )
>     , ( 0x01ca, "NJ" )
>     , ( 0x01cb, "Nj" )
>     , ( 0x01cc, "nj" )
>     , ( 0x01cd, "Acaron" )
>     , ( 0x01ce, "acaron" )
>     , ( 0x01cf, "Icaron" )
>     , ( 0x01d0, "icaron" )
>     , ( 0x01d1, "Ocaron" )
>     , ( 0x01d2, "ocaron" )
>     , ( 0x01d3, "Ucaron" )
>     , ( 0x01d4, "ucaron" )
>     , ( 0x01d5, "Udieresismacron" )
>     , ( 0x01d6, "udieresismacron" )
>     , ( 0x01d7, "Udieresisacute" )
>     , ( 0x01d8, "udieresisacute" )
>     , ( 0x01d9, "Udieresiscaron" )
>     , ( 0x01da, "udieresiscaron" )
>     , ( 0x01db, "Udieresisgrave" )
>     , ( 0x01dc, "udieresisgrave" )
>     , ( 0x01dd, "eturned" )
>     , ( 0x01de, "Adieresismacron" )
>     , ( 0x01df, "adieresismacron" )
>     , ( 0x01e0, "Adotmacron" )
>     , ( 0x01e1, "adotmacron" )
>     , ( 0x01e2, "AEmacron" )
>     , ( 0x01e3, "aemacron" )
>     , ( 0x01e4, "Gstroke" )
>     , ( 0x01e5, "gstroke" )
>     , ( 0x01e6, "Gcaron" )
>     , ( 0x01e7, "gcaron" )
>     , ( 0x01e8, "Kcaron" )
>     , ( 0x01e9, "kcaron" )
>     , ( 0x01ea, "Oogonek" )
>     , ( 0x01eb, "oogonek" )
>     , ( 0x01ec, "Oogonekmacron" )
>     , ( 0x01ed, "oogonekmacron" )
>     , ( 0x01ee, "Ezhcaron" )
>     , ( 0x01ef, "ezhcaron" )
>     , ( 0x01f0, "jcaron" )
>     , ( 0x01f1, "DZ" )
>     , ( 0x01f2, "Dz" )
>     , ( 0x01f3, "dz" )
>     , ( 0x01f4, "Gacute" )
>     , ( 0x01f5, "gacute" )
>     , ( 0x01fa, "Aringacute" )
>     , ( 0x01fb, "aringacute" )
>     , ( 0x01fc, "AEacute" )
>     , ( 0x01fd, "aeacute" )
>     , ( 0x01fe, "Oslashacute" )
>     , ( 0x01ff, "oslashacute" )
>     , ( 0x0200, "Adblgrave" )
>     , ( 0x0201, "adblgrave" )
>     , ( 0x0202, "Ainvertedbreve" )
>     , ( 0x0203, "ainvertedbreve" )
>     , ( 0x0204, "Edblgrave" )
>     , ( 0x0205, "edblgrave" )
>     , ( 0x0206, "Einvertedbreve" )
>     , ( 0x0207, "einvertedbreve" )
>     , ( 0x0208, "Idblgrave" )
>     , ( 0x0209, "idblgrave" )
>     , ( 0x020a, "Iinvertedbreve" )
>     , ( 0x020b, "iinvertedbreve" )
>     , ( 0x020c, "Odblgrave" )
>     , ( 0x020d, "odblgrave" )
>     , ( 0x020e, "Oinvertedbreve" )
>     , ( 0x020f, "oinvertedbreve" )
>     , ( 0x0210, "Rdblgrave" )
>     , ( 0x0211, "rdblgrave" )
>     , ( 0x0212, "Rinvertedbreve" )
>     , ( 0x0213, "rinvertedbreve" )
>     , ( 0x0214, "Udblgrave" )
>     , ( 0x0215, "udblgrave" )
>     , ( 0x0216, "Uinvertedbreve" )
>     , ( 0x0217, "uinvertedbreve" )
>     , ( 0x0218, "Scommaaccent" )
>     , ( 0x0219, "scommaaccent" )
>     , ( 0x0250, "aturned" )
>     , ( 0x0251, "ascript" )
>     , ( 0x0252, "ascriptturned" )
>     , ( 0x0253, "bhook" )
>     , ( 0x0254, "oopen" )
>     , ( 0x0255, "ccurl" )
>     , ( 0x0256, "dtail" )
>     , ( 0x0257, "dhook" )
>     , ( 0x0258, "ereversed" )
>     , ( 0x0259, "schwa" )
>     , ( 0x025a, "schwahook" )
>     , ( 0x025b, "eopen" )
>     , ( 0x025c, "eopenreversed" )
>     , ( 0x025d, "eopenreversedhook" )
>     , ( 0x025e, "eopenreversedclosed" )
>     , ( 0x025f, "jdotlessstroke" )
>     , ( 0x0260, "ghook" )
>     , ( 0x0261, "gscript" )
>     , ( 0x0263, "gammalatinsmall" )
>     , ( 0x0264, "ramshorn" )
>     , ( 0x0265, "hturned" )
>     , ( 0x0266, "hhook" )
>     , ( 0x0267, "henghook" )
>     , ( 0x0268, "istroke" )
>     , ( 0x0269, "iotalatin" )
>     , ( 0x026b, "lmiddletilde" )
>     , ( 0x026c, "lbelt" )
>     , ( 0x026d, "lhookretroflex" )
>     , ( 0x026e, "lezh" )
>     , ( 0x026f, "mturned" )
>     , ( 0x0270, "mlonglegturned" )
>     , ( 0x0271, "mhook" )
>     , ( 0x0272, "nhookleft" )
>     , ( 0x0273, "nhookretroflex" )
>     , ( 0x0275, "obarred" )
>     , ( 0x0277, "omegalatinclosed" )
>     , ( 0x0278, "philatin" )
>     , ( 0x0279, "rturned" )
>     , ( 0x027a, "rlonglegturned" )
>     , ( 0x027b, "rhookturned" )
>     , ( 0x027c, "rlongleg" )
>     , ( 0x027d, "rhook" )
>     , ( 0x027e, "rfishhook" )
>     , ( 0x027f, "rfishhookreversed" )
>     , ( 0x0281, "Rsmallinverted" )
>     , ( 0x0282, "shook" )
>     , ( 0x0283, "esh" )
>     , ( 0x0284, "dotlessjstrokehook" )
>     , ( 0x0285, "eshsquatreversed" )
>     , ( 0x0286, "eshcurl" )
>     , ( 0x0287, "tturned" )
>     , ( 0x0288, "tretroflexhook" )
>     , ( 0x0289, "ubar" )
>     , ( 0x028a, "upsilonlatin" )
>     , ( 0x028b, "vhook" )
>     , ( 0x028c, "vturned" )
>     , ( 0x028d, "wturned" )
>     , ( 0x028e, "yturned" )
>     , ( 0x0290, "zretroflexhook" )
>     , ( 0x0291, "zcurl" )
>     , ( 0x0292, "ezh" )
>     , ( 0x0293, "ezhcurl" )
>     , ( 0x0294, "glottalstop" )
>     , ( 0x0295, "glottalstopreversed" )
>     , ( 0x0296, "glottalstopinverted" )
>     , ( 0x0297, "cstretched" )
>     , ( 0x0298, "bilabialclick" )
>     , ( 0x029a, "eopenclosed" )
>     , ( 0x029b, "Gsmallhook" )
>     , ( 0x029d, "jcrossedtail" )
>     , ( 0x029e, "kturned" )
>     , ( 0x02a0, "qhook" )
>     , ( 0x02a1, "glottalstopstroke" )
>     , ( 0x02a2, "glottalstopstrokereversed" )
>     , ( 0x02a3, "dzaltone" )
>     , ( 0x02a4, "dezh" )
>     , ( 0x02a5, "dzcurl" )
>     , ( 0x02a6, "ts" )
>     , ( 0x02a7, "tesh" )
>     , ( 0x02a8, "tccurl" )
>     , ( 0x02b0, "hsuperior" )
>     , ( 0x02b1, "hhooksuperior" )
>     , ( 0x02b2, "jsuperior" )
>     , ( 0x02b4, "rturnedsuperior" )
>     , ( 0x02b5, "rhookturnedsuperior" )
>     , ( 0x02b6, "Rsmallinvertedsuperior" )
>     , ( 0x02b7, "wsuperior" )
>     , ( 0x02b8, "ysuperior" )
>     , ( 0x02b9, "primemod" )
>     , ( 0x02ba, "dblprimemod" )
>     , ( 0x02bb, "commaturnedmod" )
>     , ( 0x02bc, "afii57929" )
>     , ( 0x02bd, "afii64937" )
>     , ( 0x02be, "ringhalfright" )
>     , ( 0x02bf, "ringhalfleft" )
>     , ( 0x02c0, "glottalstopmod" )
>     , ( 0x02c1, "glottalstopreversedmod" )
>     , ( 0x02c2, "arrowheadleftmod" )
>     , ( 0x02c3, "arrowheadrightmod" )
>     , ( 0x02c4, "arrowheadupmod" )
>     , ( 0x02c5, "arrowheaddownmod" )
>     , ( 0x02c6, "circumflex" )
>     , ( 0x02c7, "caron" )
>     , ( 0x02c8, "verticallinemod" )
>     , ( 0x02c9, "firsttonechinese" )
>     , ( 0x02ca, "secondtonechinese" )
>     , ( 0x02cb, "fourthtonechinese" )
>     , ( 0x02cc, "verticallinelowmod" )
>     , ( 0x02cd, "macronlowmod" )
>     , ( 0x02ce, "gravelowmod" )
>     , ( 0x02cf, "acutelowmod" )
>     , ( 0x02d0, "colontriangularmod" )
>     , ( 0x02d1, "colontriangularhalfmod" )
>     , ( 0x02d2, "ringhalfrightcentered" )
>     , ( 0x02d3, "ringhalfleftcentered" )
>     , ( 0x02d4, "uptackmod" )
>     , ( 0x02d5, "downtackmod" )
>     , ( 0x02d6, "plusmod" )
>     , ( 0x02d7, "minusmod" )
>     , ( 0x02d8, "breve" )
>     , ( 0x02d9, "dotaccent" )
>     , ( 0x02da, "ring" )
>     , ( 0x02db, "ogonek" )
>     , ( 0x02dc, "ilde" )
>     , ( 0x02dd, "hungarumlaut" )
>     , ( 0x02de, "rhotichookmod" )
>     , ( 0x02e0, "gammasuperior" )
>     , ( 0x02e3, "xsuperior" )
>     , ( 0x02e4, "glottalstopreversedsuperior" )
>     , ( 0x02e5, "tonebarextrahighmod" )
>     , ( 0x02e6, "tonebarhighmod" )
>     , ( 0x02e7, "tonebarmidmod" )
>     , ( 0x02e8, "tonebarlowmod" )
>     , ( 0x02e9, "tonebarextralowmod" )
>     , ( 0x0300, "gravecmb" )
>     , ( 0x0301, "acutecmb" )
>     , ( 0x0302, "circumflexcmb" )
>     , ( 0x0303, "tildecmb" )
>     , ( 0x0304, "macroncmb" )
>     , ( 0x0305, "overlinecmb" )
>     , ( 0x0306, "brevecmb" )
>     , ( 0x0307, "dotaccentcmb" )
>     , ( 0x0308, "dieresiscmb" )
>     , ( 0x0309, "hookabovecomb" )
>     , ( 0x030a, "ringcmb" )
>     , ( 0x030b, "hungarumlautcmb" )
>     , ( 0x030c, "caroncmb" )
>     , ( 0x030d, "verticallineabovecmb" )
>     , ( 0x030e, "dblverticallineabovecmb" )
>     , ( 0x030f, "dblgravecmb" )
>     , ( 0x0310, "candrabinducmb" )
>     , ( 0x0311, "breveinvertedcmb" )
>     , ( 0x0312, "commaturnedabovecmb" )
>     , ( 0x0313, "commaabovecmb" )
>     , ( 0x0314, "commareversedabovecmb" )
>     , ( 0x0315, "commaaboverightcmb" )
>     , ( 0x0316, "gravebelowcmb" )
>     , ( 0x0317, "acutebelowcmb" )
>     , ( 0x0318, "lefttackbelowcmb" )
>     , ( 0x0319, "righttackbelowcmb" )
>     , ( 0x031a, "leftangleabovecmb" )
>     , ( 0x031b, "horncmb" )
>     , ( 0x031c, "ringhalfleftbelowcmb" )
>     , ( 0x031d, "uptackbelowcmb" )
>     , ( 0x031e, "downtackbelowcmb" )
>     , ( 0x031f, "plusbelowcmb" )
>     , ( 0x0320, "minusbelowcmb" )
>     , ( 0x0321, "hookpalatalizedbelowcmb" )
>     , ( 0x0322, "hookretroflexbelowcmb" )
>     , ( 0x0323, "dotbelowcmb" )
>     , ( 0x0324, "dieresisbelowcmb" )
>     , ( 0x0325, "ringbelowcmb" )
>     , ( 0x0327, "cedillacmb" )
>     , ( 0x0328, "ogonekcmb" )
>     , ( 0x0329, "verticallinebelowcmb" )
>     , ( 0x032a, "bridgebelowcmb" )
>     , ( 0x032b, "dblarchinvertedbelowcmb" )
>     , ( 0x032c, "caronbelowcmb" )
>     , ( 0x032d, "circumflexbelowcmb" )
>     , ( 0x032e, "brevebelowcmb" )
>     , ( 0x032f, "breveinvertedbelowcmb" )
>     , ( 0x0330, "tildebelowcmb" )
>     , ( 0x0331, "macronbelowcmb" )
>     , ( 0x0332, "lowlinecmb" )
>     , ( 0x0333, "dbllowlinecmb" )
>     , ( 0x0334, "tildeoverlaycmb" )
>     , ( 0x0335, "strokeshortoverlaycmb" )
>     , ( 0x0336, "strokelongoverlaycmb" )
>     , ( 0x0337, "solidusshortoverlaycmb" )
>     , ( 0x0338, "soliduslongoverlaycmb" )
>     , ( 0x0339, "ringhalfrightbelowcmb" )
>     , ( 0x033a, "bridgeinvertedbelowcmb" )
>     , ( 0x033b, "squarebelowcmb" )
>     , ( 0x033c, "seagullbelowcmb" )
>     , ( 0x033d, "xabovecmb" )
>     , ( 0x033e, "tildeverticalcmb" )
>     , ( 0x033f, "dbloverlinecmb" )
>     , ( 0x0340, "gravetonecmb" )
>     , ( 0x0341, "acutetonecmb" )
>     , ( 0x0342, "perispomenigreekcmb" )
>     , ( 0x0343, "koroniscmb" )
>     , ( 0x0344, "dialytikatonoscmb" )
>     , ( 0x0345, "ypogegrammenigreekcmb" )
>     , ( 0x0360, "tildedoublecmb" )
>     , ( 0x0361, "breveinverteddoublecmb" )
>     , ( 0x0374, "numeralsigngreek" )
>     , ( 0x0375, "numeralsignlowergreek" )
>     , ( 0x037a, "ypogegrammeni" )
>     , ( 0x037e, "questiongreek" )
>     , ( 0x0384, "tonos" )
>     , ( 0x0385, "dialytikatonos" )
>     , ( 0x0386, "Alphatonos" )
>     , ( 0x0387, "anoteleia" )
>     , ( 0x0388, "Epsilontonos" )
>     , ( 0x0389, "Etatonos" )
>     , ( 0x038a, "Iotatonos" )
>     , ( 0x038c, "Omicrontonos" )
>     , ( 0x038e, "Upsilontonos" )
>     , ( 0x038f, "Omegatonos" )
>     , ( 0x0390, "iotadieresistonos" )
>     , ( 0x0391, "Alpha" )
>     , ( 0x0392, "Beta" )
>     , ( 0x0393, "Gamma" )
>     , ( 0x0394, "Deltagreek" )
>     , ( 0x0395, "Epsilon" )
>     , ( 0x0396, "Zeta" )
>     , ( 0x0397, "Eta" )
>     , ( 0x0398, "Theta" )
>     , ( 0x0399, "Iota" )
>     , ( 0x039a, "Kappa" )
>     , ( 0x039b, "Lambda" )
>     , ( 0x039c, "Mu" )
>     , ( 0x039d, "Nu" )
>     , ( 0x039e, "Xi" )
>     , ( 0x039f, "Omicron" )
>     , ( 0x03a0, "Pi" )
>     , ( 0x03a1, "Rho" )
>     , ( 0x03a3, "Sigma" )
>     , ( 0x03a4, "Tau" )
>     , ( 0x03a5, "Upsilon" )
>     , ( 0x03a6, "Phi" )
>     , ( 0x03a7, "Chi" )
>     , ( 0x03a8, "Psi" )
>     , ( 0x03a9, "Omegagreek" )
>     , ( 0x03aa, "Iotadieresis" )
>     , ( 0x03ab, "Upsilondieresis" )
>     , ( 0x03ac, "alphatonos" )
>     , ( 0x03ad, "epsilontonos" )
>     , ( 0x03ae, "etatonos" )
>     , ( 0x03af, "iotatonos" )
>     , ( 0x03b0, "upsilondieresistonos" )
>     , ( 0x03b1, "alpha" )
>     , ( 0x03b2, "beta" )
>     , ( 0x03b3, "gamma" )
>     , ( 0x03b4, "delta" )
>     , ( 0x03b5, "epsilon" )
>     , ( 0x03b6, "zeta" )
>     , ( 0x03b7, "eta" )
>     , ( 0x03b8, "theta" )
>     , ( 0x03b9, "iota" )
>     , ( 0x03ba, "kappa" )
>     , ( 0x03bb, "lambda" )
>     , ( 0x03bc, "mugreek" )
>     , ( 0x03bd, "nu" )
>     , ( 0x03be, "xi" )
>     , ( 0x03bf, "omicron" )
>     , ( 0x03c0, "pi" )
>     , ( 0x03c1, "rho" )
>     , ( 0x03c2, "sigma1" )
>     , ( 0x03c3, "sigma" )
>     , ( 0x03c4, "tau" )
>     , ( 0x03c5, "upsilon" )
>     , ( 0x03c6, "phi" )
>     , ( 0x03c7, "chi" )
>     , ( 0x03c8, "psi" )
>     , ( 0x03c9, "omega" )
>     , ( 0x03ca, "iotadieresis" )
>     , ( 0x03cb, "upsilondieresis" )
>     , ( 0x03cc, "omicrontonos" )
>     , ( 0x03cd, "upsilontonos" )
>     , ( 0x03ce, "omegatonos" )
>     , ( 0x03d0, "betasymbolgreek" )
>     , ( 0x03d1, "theta1" )
>     , ( 0x03d2, "Upsilon1" )
>     , ( 0x03d3, "Upsilonacutehooksymbolgreek" )
>     , ( 0x03d4, "Upsilondieresishooksymbolgreek" )
>     , ( 0x03d5, "phi1" )
>     , ( 0x03d6, "omega1" )
>     , ( 0x03da, "Stigmagreek" )
>     , ( 0x03dc, "Digammagreek" )
>     , ( 0x03de, "Koppagreek" )
>     , ( 0x03e0, "Sampigreek" )
>     , ( 0x03e2, "Sheicoptic" )
>     , ( 0x03e3, "sheicoptic" )
>     , ( 0x03e4, "Feicoptic" )
>     , ( 0x03e5, "feicoptic" )
>     , ( 0x03e6, "Kheicoptic" )
>     , ( 0x03e7, "kheicoptic" )
>     , ( 0x03e8, "Horicoptic" )
>     , ( 0x03e9, "horicoptic" )
>     , ( 0x03ea, "Gangiacoptic" )
>     , ( 0x03eb, "gangiacoptic" )
>     , ( 0x03ec, "Shimacoptic" )
>     , ( 0x03ed, "shimacoptic" )
>     , ( 0x03ee, "Deicoptic" )
>     , ( 0x03ef, "deicoptic" )
>     , ( 0x03f0, "kappasymbolgreek" )
>     , ( 0x03f1, "rhosymbolgreek" )
>     , ( 0x03f2, "sigmalunatesymbolgreek" )
>     , ( 0x03f3, "yotgreek" )
>     , ( 0x0401, "Iocyrillic" )
>     , ( 0x0402, "Djecyrillic" )
>     , ( 0x0403, "Gjecyrillic" )
>     , ( 0x0404, "Ecyrillic" )
>     , ( 0x0405, "Dzecyrillic" )
>     , ( 0x0406, "Icyrillic" )
>     , ( 0x0407, "Yicyrillic" )
>     , ( 0x0408, "Jecyrillic" )
>     , ( 0x0409, "Ljecyrillic" )
>     , ( 0x040a, "Njecyrillic" )
>     , ( 0x040b, "Tshecyrillic" )
>     , ( 0x040c, "Kjecyrillic" )
>     , ( 0x040e, "Ushortcyrillic" )
>     , ( 0x040f, "Dzhecyrillic" )
>     , ( 0x0410, "Acyrillic" )
>     , ( 0x0411, "Becyrillic" )
>     , ( 0x0412, "Vecyrillic" )
>     , ( 0x0413, "Gecyrillic" )
>     , ( 0x0414, "Decyrillic" )
>     , ( 0x0415, "Iecyrillic" )
>     , ( 0x0416, "Zhecyrillic" )
>     , ( 0x0417, "Zecyrillic" )
>     , ( 0x0418, "Iicyrillic" )
>     , ( 0x0419, "Iishortcyrillic" )
>     , ( 0x041a, "Kacyrillic" )
>     , ( 0x041b, "Elcyrillic" )
>     , ( 0x041c, "Emcyrillic" )
>     , ( 0x041d, "Encyrillic" )
>     , ( 0x041e, "Ocyrillic" )
>     , ( 0x041f, "Pecyrillic" )
>     , ( 0x0420, "Ercyrillic" )
>     , ( 0x0421, "Escyrillic" )
>     , ( 0x0422, "Tecyrillic" )
>     , ( 0x0423, "Ucyrillic" )
>     , ( 0x0424, "Efcyrillic" )
>     , ( 0x0425, "Khacyrillic" )
>     , ( 0x0426, "Tsecyrillic" )
>     , ( 0x0427, "Checyrillic" )
>     , ( 0x0428, "Shacyrillic" )
>     , ( 0x0429, "Shchacyrillic" )
>     , ( 0x042a, "Hardsigncyrillic" )
>     , ( 0x042b, "Yericyrillic" )
>     , ( 0x042c, "Softsigncyrillic" )
>     , ( 0x042d, "Ereversedcyrillic" )
>     , ( 0x042e, "IUcyrillic" )
>     , ( 0x042f, "IAcyrillic" )
>     , ( 0x0430, "acyrillic" )
>     , ( 0x0431, "afii10066" )
>     , ( 0x0432, "afii10067" )
>     , ( 0x0433, "afii10068" )
>     , ( 0x0434, "afii10069" )
>     , ( 0x0435, "afii10070" )
>     , ( 0x0436, "afii10072" )
>     , ( 0x0437, "afii10073" )
>     , ( 0x0438, "afii10074" )
>     , ( 0x0439, "afii10075" )
>     , ( 0x043a, "afii10076" )
>     , ( 0x043b, "afii10077" )
>     , ( 0x043c, "afii10078" )
>     , ( 0x043d, "afii10079" )
>     , ( 0x043e, "afii10080" )
>     , ( 0x043f, "afii10081" )
>     , ( 0x0440, "afii10082" )
>     , ( 0x0441, "afii10083" )
>     , ( 0x0442, "afii10084" )
>     , ( 0x0443, "afii10085" )
>     , ( 0x0444, "afii10086" )
>     , ( 0x0445, "afii10087" )
>     , ( 0x0446, "afii10088" )
>     , ( 0x0447, "afii10089" )
>     , ( 0x0448, "afii10090" )
>     , ( 0x0449, "afii10091" )
>     , ( 0x044a, "afii10092" )
>     , ( 0x044b, "afii10093" )
>     , ( 0x044c, "afii10094" )
>     , ( 0x044d, "afii10095" )
>     , ( 0x044e, "afii10096" )
>     , ( 0x044f, "afii10097" )
>     , ( 0x0451, "afii10071" )
>     , ( 0x0452, "afii10099" )
>     , ( 0x0453, "afii10100" )
>     , ( 0x0454, "afii10101" )
>     , ( 0x0455, "afii10102" )
>     , ( 0x0456, "afii10103" )
>     , ( 0x0457, "afii10104" )
>     , ( 0x0458, "afii10105" )
>     , ( 0x0459, "afii10106" )
>     , ( 0x045a, "afii10107" )
>     , ( 0x045b, "afii10108" )
>     , ( 0x045c, "afii10109" )
>     , ( 0x045e, "afii10110" )
>     , ( 0x045f, "afii10193" )
>     , ( 0x0460, "Omegacyrillic" )
>     , ( 0x0461, "omegacyrillic" )
>     , ( 0x0462, "Yatcyrillic" )
>     , ( 0x0463, "afii10194" )
>     , ( 0x0464, "Eiotifiedcyrillic" )
>     , ( 0x0465, "eiotifiedcyrillic" )
>     , ( 0x0466, "Yuslittlecyrillic" )
>     , ( 0x0467, "yuslittlecyrillic" )
>     , ( 0x0468, "Yuslittleiotifiedcyrillic" )
>     , ( 0x0469, "yuslittleiotifiedcyrillic" )
>     , ( 0x046a, "Yusbigcyrillic" )
>     , ( 0x046b, "yusbigcyrillic" )
>     , ( 0x046c, "Yusbigiotifiedcyrillic" )
>     , ( 0x046d, "yusbigiotifiedcyrillic" )
>     , ( 0x046e, "Ksicyrillic" )
>     , ( 0x046f, "ksicyrillic" )
>     , ( 0x0470, "Psicyrillic" )
>     , ( 0x0471, "psicyrillic" )
>     , ( 0x0472, "Fitacyrillic" )
>     , ( 0x0473, "afii10195" )
>     , ( 0x0474, "Izhitsacyrillic" )
>     , ( 0x0475, "afii10196" )
>     , ( 0x0476, "Izhitsadblgravecyrillic" )
>     , ( 0x0477, "izhitsadblgravecyrillic" )
>     , ( 0x0478, "Ukcyrillic" )
>     , ( 0x0479, "ukcyrillic" )
>     , ( 0x047a, "Omegaroundcyrillic" )
>     , ( 0x047b, "omegaroundcyrillic" )
>     , ( 0x047c, "Omegatitlocyrillic" )
>     , ( 0x047d, "omegatitlocyrillic" )
>     , ( 0x047e, "Otcyrillic" )
>     , ( 0x047f, "otcyrillic" )
>     , ( 0x0480, "Koppacyrillic" )
>     , ( 0x0481, "koppacyrillic" )
>     , ( 0x0482, "thousandcyrillic" )
>     , ( 0x0483, "titlocyrilliccmb" )
>     , ( 0x0484, "palatalizationcyrilliccmb" )
>     , ( 0x0485, "dasiapneumatacyrilliccmb" )
>     , ( 0x0486, "psilipneumatacyrilliccmb" )
>     , ( 0x0490, "Gheupturncyrillic" )
>     , ( 0x0491, "afii10098" )
>     , ( 0x0492, "Ghestrokecyrillic" )
>     , ( 0x0493, "ghestrokecyrillic" )
>     , ( 0x0494, "Ghemiddlehookcyrillic" )
>     , ( 0x0495, "ghemiddlehookcyrillic" )
>     , ( 0x0496, "Zhedescendercyrillic" )
>     , ( 0x0497, "zhedescendercyrillic" )
>     , ( 0x0498, "Zedescendercyrillic" )
>     , ( 0x0499, "zedescendercyrillic" )
>     , ( 0x049a, "Kadescendercyrillic" )
>     , ( 0x049b, "kadescendercyrillic" )
>     , ( 0x049c, "Kaverticalstrokecyrillic" )
>     , ( 0x049d, "kaverticalstrokecyrillic" )
>     , ( 0x049e, "Kastrokecyrillic" )
>     , ( 0x049f, "kastrokecyrillic" )
>     , ( 0x04a0, "Kabashkircyrillic" )
>     , ( 0x04a1, "kabashkircyrillic" )
>     , ( 0x04a2, "Endescendercyrillic" )
>     , ( 0x04a3, "endescendercyrillic" )
>     , ( 0x04a4, "Enghecyrillic" )
>     , ( 0x04a5, "enghecyrillic" )
>     , ( 0x04a6, "Pemiddlehookcyrillic" )
>     , ( 0x04a7, "pemiddlehookcyrillic" )
>     , ( 0x04a8, "Haabkhasiancyrillic" )
>     , ( 0x04a9, "haabkhasiancyrillic" )
>     , ( 0x04aa, "Esdescendercyrillic" )
>     , ( 0x04ab, "esdescendercyrillic" )
>     , ( 0x04ac, "Tedescendercyrillic" )
>     , ( 0x04ad, "tedescendercyrillic" )
>     , ( 0x04ae, "Ustraightcyrillic" )
>     , ( 0x04af, "ustraightcyrillic" )
>     , ( 0x04b0, "Ustraightstrokecyrillic" )
>     , ( 0x04b1, "ustraightstrokecyrillic" )
>     , ( 0x04b2, "Hadescendercyrillic" )
>     , ( 0x04b3, "hadescendercyrillic" )
>     , ( 0x04b4, "Tetsecyrillic" )
>     , ( 0x04b5, "tetsecyrillic" )
>     , ( 0x04b6, "Chedescendercyrillic" )
>     , ( 0x04b7, "chedescendercyrillic" )
>     , ( 0x04b8, "Cheverticalstrokecyrillic" )
>     , ( 0x04b9, "cheverticalstrokecyrillic" )
>     , ( 0x04ba, "Shhacyrillic" )
>     , ( 0x04bb, "shhacyrillic" )
>     , ( 0x04bc, "Cheabkhasiancyrillic" )
>     , ( 0x04bd, "cheabkhasiancyrillic" )
>     , ( 0x04be, "Chedescenderabkhasiancyrillic" )
>     , ( 0x04bf, "chedescenderabkhasiancyrillic" )
>     , ( 0x04c0, "palochkacyrillic" )
>     , ( 0x04c1, "Zhebrevecyrillic" )
>     , ( 0x04c2, "zhebrevecyrillic" )
>     , ( 0x04c3, "Kahookcyrillic" )
>     , ( 0x04c4, "kahookcyrillic" )
>     , ( 0x04c7, "Enhookcyrillic" )
>     , ( 0x04c8, "enhookcyrillic" )
>     , ( 0x04cb, "Chekhakassiancyrillic" )
>     , ( 0x04cc, "chekhakassiancyrillic" )
>     , ( 0x04d0, "Abrevecyrillic" )
>     , ( 0x04d1, "abrevecyrillic" )
>     , ( 0x04d2, "Adieresiscyrillic" )
>     , ( 0x04d3, "adieresiscyrillic" )
>     , ( 0x04d4, "Aiecyrillic" )
>     , ( 0x04d5, "aiecyrillic" )
>     , ( 0x04d6, "Iebrevecyrillic" )
>     , ( 0x04d7, "iebrevecyrillic" )
>     , ( 0x04d8, "Schwacyrillic" )
>     , ( 0x04d9, "afii10846" )
>     , ( 0x04da, "Schwadieresiscyrillic" )
>     , ( 0x04db, "schwadieresiscyrillic" )
>     , ( 0x04dc, "Zhedieresiscyrillic" )
>     , ( 0x04dd, "zhedieresiscyrillic" )
>     , ( 0x04de, "Zedieresiscyrillic" )
>     , ( 0x04df, "zedieresiscyrillic" )
>     , ( 0x04e0, "Dzeabkhasiancyrillic" )
>     , ( 0x04e1, "dzeabkhasiancyrillic" )
>     , ( 0x04e2, "Imacroncyrillic" )
>     , ( 0x04e3, "imacroncyrillic" )
>     , ( 0x04e4, "Idieresiscyrillic" )
>     , ( 0x04e5, "idieresiscyrillic" )
>     , ( 0x04e6, "Odieresiscyrillic" )
>     , ( 0x04e7, "odieresiscyrillic" )
>     , ( 0x04e8, "Obarredcyrillic" )
>     , ( 0x04e9, "obarredcyrillic" )
>     , ( 0x04ea, "Obarreddieresiscyrillic" )
>     , ( 0x04eb, "obarreddieresiscyrillic" )
>     , ( 0x04ee, "Umacroncyrillic" )
>     , ( 0x04ef, "umacroncyrillic" )
>     , ( 0x04f0, "Udieresiscyrillic" )
>     , ( 0x04f1, "udieresiscyrillic" )
>     , ( 0x04f2, "Uhungarumlautcyrillic" )
>     , ( 0x04f3, "uhungarumlautcyrillic" )
>     , ( 0x04f4, "Chedieresiscyrillic" )
>     , ( 0x04f5, "chedieresiscyrillic" )
>     , ( 0x04f8, "Yerudieresiscyrillic" )
>     , ( 0x04f9, "yerudieresiscyrillic" )
>     , ( 0x0531, "Aybarmenian" )
>     , ( 0x0532, "Benarmenian" )
>     , ( 0x0533, "Gimarmenian" )
>     , ( 0x0534, "Daarmenian" )
>     , ( 0x0535, "Echarmenian" )
>     , ( 0x0536, "Zaarmenian" )
>     , ( 0x0537, "Eharmenian" )
>     , ( 0x0538, "Etarmenian" )
>     , ( 0x0539, "Toarmenian" )
>     , ( 0x053a, "Zhearmenian" )
>     , ( 0x053b, "Iniarmenian" )
>     , ( 0x053c, "Liwnarmenian" )
>     , ( 0x053d, "Xeharmenian" )
>     , ( 0x053e, "Caarmenian" )
>     , ( 0x053f, "Kenarmenian" )
>     , ( 0x0540, "Hoarmenian" )
>     , ( 0x0541, "Jaarmenian" )
>     , ( 0x0542, "Ghadarmenian" )
>     , ( 0x0543, "Cheharmenian" )
>     , ( 0x0544, "Menarmenian" )
>     , ( 0x0545, "Yiarmenian" )
>     , ( 0x0546, "Nowarmenian" )
>     , ( 0x0547, "Shaarmenian" )
>     , ( 0x0548, "Voarmenian" )
>     , ( 0x0549, "Chaarmenian" )
>     , ( 0x054a, "Peharmenian" )
>     , ( 0x054b, "Jheharmenian" )
>     , ( 0x054c, "Raarmenian" )
>     , ( 0x054d, "Seharmenian" )
>     , ( 0x054e, "Vewarmenian" )
>     , ( 0x054f, "Tiwnarmenian" )
>     , ( 0x0550, "Reharmenian" )
>     , ( 0x0551, "Coarmenian" )
>     , ( 0x0552, "Yiwnarmenian" )
>     , ( 0x0553, "Piwrarmenian" )
>     , ( 0x0554, "Keharmenian" )
>     , ( 0x0555, "Oharmenian" )
>     , ( 0x0556, "Feharmenian" )
>     , ( 0x0559, "ringhalfleftarmenian" )
>     , ( 0x055a, "apostrophearmenian" )
>     , ( 0x055b, "emphasismarkarmenian" )
>     , ( 0x055c, "exclamarmenian" )
>     , ( 0x055d, "commaarmenian" )
>     , ( 0x055e, "questionarmenian" )
>     , ( 0x055f, "abbreviationmarkarmenian" )
>     , ( 0x0561, "aybarmenian" )
>     , ( 0x0562, "benarmenian" )
>     , ( 0x0563, "gimarmenian" )
>     , ( 0x0564, "daarmenian" )
>     , ( 0x0565, "echarmenian" )
>     , ( 0x0566, "zaarmenian" )
>     , ( 0x0567, "eharmenian" )
>     , ( 0x0568, "etarmenian" )
>     , ( 0x0569, "toarmenian" )
>     , ( 0x056a, "zhearmenian" )
>     , ( 0x056b, "iniarmenian" )
>     , ( 0x056c, "liwnarmenian" )
>     , ( 0x056d, "xeharmenian" )
>     , ( 0x056e, "caarmenian" )
>     , ( 0x056f, "kenarmenian" )
>     , ( 0x0570, "hoarmenian" )
>     , ( 0x0571, "jaarmenian" )
>     , ( 0x0572, "ghadarmenian" )
>     , ( 0x0573, "cheharmenian" )
>     , ( 0x0574, "menarmenian" )
>     , ( 0x0575, "yiarmenian" )
>     , ( 0x0576, "nowarmenian" )
>     , ( 0x0577, "shaarmenian" )
>     , ( 0x0578, "voarmenian" )
>     , ( 0x0579, "chaarmenian" )
>     , ( 0x057a, "peharmenian" )
>     , ( 0x057b, "jheharmenian" )
>     , ( 0x057c, "raarmenian" )
>     , ( 0x057d, "seharmenian" )
>     , ( 0x057e, "vewarmenian" )
>     , ( 0x057f, "tiwnarmenian" )
>     , ( 0x0580, "reharmenian" )
>     , ( 0x0581, "coarmenian" )
>     , ( 0x0582, "yiwnarmenian" )
>     , ( 0x0583, "piwrarmenian" )
>     , ( 0x0584, "keharmenian" )
>     , ( 0x0585, "oharmenian" )
>     , ( 0x0586, "feharmenian" )
>     , ( 0x0587, "echyiwnarmenian" )
>     , ( 0x0589, "periodarmenian" )
>     , ( 0x0591, "etnahtafoukhhebrew" )
>     , ( 0x0592, "segoltahebrew" )
>     , ( 0x0593, "shalshelethebrew" )
>     , ( 0x0594, "zaqefqatanhebrew" )
>     , ( 0x0595, "zaqefgadolhebrew" )
>     , ( 0x0596, "tipehahebrew" )
>     , ( 0x0597, "reviahebrew" )
>     , ( 0x0598, "zarqahebrew" )
>     , ( 0x0599, "pashtahebrew" )
>     , ( 0x059a, "yetivhebrew" )
>     , ( 0x059b, "tevirhebrew" )
>     , ( 0x059c, "gereshaccenthebrew" )
>     , ( 0x059d, "gereshmuqdamhebrew" )
>     , ( 0x059e, "gershayimaccenthebrew" )
>     , ( 0x059f, "qarneyparahebrew" )
>     , ( 0x05a0, "telishagedolahebrew" )
>     , ( 0x05a1, "pazerhebrew" )
>     , ( 0x05a3, "munahhebrew" )
>     , ( 0x05a4, "mahapakhhebrew" )
>     , ( 0x05a5, "merkhahebrew" )
>     , ( 0x05a6, "merkhakefulahebrew" )
>     , ( 0x05a7, "dargahebrew" )
>     , ( 0x05a8, "qadmahebrew" )
>     , ( 0x05a9, "telishaqetanahebrew" )
>     , ( 0x05aa, "yerahbenyomohebrew" )
>     , ( 0x05ab, "olehebrew" )
>     , ( 0x05ac, "iluyhebrew" )
>     , ( 0x05ad, "dehihebrew" )
>     , ( 0x05ae, "zinorhebrew" )
>     , ( 0x05af, "masoracirclehebrew" )
>     , ( 0x05b0, "afii57799" )
>     , ( 0x05b1, "afii57801" )
>     , ( 0x05b2, "afii57800" )
>     , ( 0x05b3, "afii57802" )
>     , ( 0x05b4, "afii57793" )
>     , ( 0x05b5, "afii57794" )
>     , ( 0x05b6, "afii57795" )
>     , ( 0x05b7, "afii57798" )
>     , ( 0x05b8, "afii57797" )
>     , ( 0x05b9, "afii57806" )
>     , ( 0x05bb, "afii57796" )
>     , ( 0x05bc, "afii57807" )
>     , ( 0x05bd, "afii57839" )
>     , ( 0x05be, "afii57645" )
>     , ( 0x05bf, "afii57841" )
>     , ( 0x05c0, "afii57842" )
>     , ( 0x05c1, "afii57804" )
>     , ( 0x05c2, "afii57803" )
>     , ( 0x05c3, "afii57658" )
>     , ( 0x05c4, "upperdothebrew" )
>     , ( 0x05d0, "afii57664" )
>     , ( 0x05d1, "afii57665" )
>     , ( 0x05d2, "afii57666" )
>     , ( 0x05d3, "afii57667" )
>     , ( 0x05d4, "afii57668" )
>     , ( 0x05d5, "afii57669" )
>     , ( 0x05d6, "afii57670" )
>     , ( 0x05d7, "afii57671" )
>     , ( 0x05d8, "afii57672" )
>     , ( 0x05d9, "afii57673" )
>     , ( 0x05da, "afii57674" )
>     , ( 0x05db, "afii57675" )
>     , ( 0x05dc, "afii57676" )
>     , ( 0x05dd, "afii57677" )
>     , ( 0x05de, "afii57678" )
>     , ( 0x05df, "afii57679" )
>     , ( 0x05e0, "afii57680" )
>     , ( 0x05e1, "afii57681" )
>     , ( 0x05e2, "afii57682" )
>     , ( 0x05e3, "afii57683" )
>     , ( 0x05e4, "afii57684" )
>     , ( 0x05e5, "afii57685" )
>     , ( 0x05e6, "afii57686" )
>     , ( 0x05e7, "afii57687" )
>     , ( 0x05e8, "afii57688" )
>     , ( 0x05e9, "afii57689" )
>     , ( 0x05ea, "afii57690" )
>     , ( 0x05f0, "afii57716" )
>     , ( 0x05f1, "afii57717" )
>     , ( 0x05f2, "afii57718" )
>     , ( 0x05f3, "gereshhebrew" )
>     , ( 0x05f4, "gershayimhebrew" )
>     , ( 0x060c, "afii57388" )
>     , ( 0x061b, "afii57403" )
>     , ( 0x061f, "afii57407" )
>     , ( 0x0621, "afii57409" )
>     , ( 0x0622, "afii57410" )
>     , ( 0x0623, "afii57411" )
>     , ( 0x0624, "afii57412" )
>     , ( 0x0625, "afii57413" )
>     , ( 0x0626, "afii57414" )
>     , ( 0x0627, "afii57415" )
>     , ( 0x0628, "afii57416" )
>     , ( 0x0629, "afii57417" )
>     , ( 0x062a, "afii57418" )
>     , ( 0x062b, "afii57419" )
>     , ( 0x062c, "afii57420" )
>     , ( 0x062d, "afii57421" )
>     , ( 0x062e, "afii57422" )
>     , ( 0x062f, "afii57423" )
>     , ( 0x0630, "afii57424" )
>     , ( 0x0631, "afii57425" )
>     , ( 0x0632, "afii57426" )
>     , ( 0x0633, "afii57427" )
>     , ( 0x0634, "afii57428" )
>     , ( 0x0635, "afii57429" )
>     , ( 0x0636, "afii57430" )
>     , ( 0x0637, "afii57431" )
>     , ( 0x0638, "afii57432" )
>     , ( 0x0639, "afii57433" )
>     , ( 0x063a, "afii57434" )
>     , ( 0x0640, "afii57440" )
>     , ( 0x0641, "afii57441" )
>     , ( 0x0642, "afii57442" )
>     , ( 0x0643, "afii57443" )
>     , ( 0x0644, "afii57444" )
>     , ( 0x0645, "afii57445" )
>     , ( 0x0646, "afii57446" )
>     , ( 0x0647, "afii57470" )
>     , ( 0x0648, "afii57448" )
>     , ( 0x0649, "afii57449" )
>     , ( 0x064a, "afii57450" )
>     , ( 0x064b, "afii57451" )
>     , ( 0x064c, "afii57452" )
>     , ( 0x064d, "afii57453" )
>     , ( 0x064e, "afii57454" )
>     , ( 0x064f, "afii57455" )
>     , ( 0x0650, "afii57456" )
>     , ( 0x0651, "afii57457" )
>     , ( 0x0652, "afii57458" )
>     , ( 0x0660, "afii57392" )
>     , ( 0x0661, "afii57393" )
>     , ( 0x0662, "afii57394" )
>     , ( 0x0663, "afii57395" )
>     , ( 0x0664, "afii57396" )
>     , ( 0x0665, "afii57397" )
>     , ( 0x0666, "afii57398" )
>     , ( 0x0667, "afii57399" )
>     , ( 0x0668, "afii57400" )
>     , ( 0x0669, "afii57401" )
>     , ( 0x066a, "afii57381" )
>     , ( 0x066b, "decimalseparatorarabic" )
>     , ( 0x066c, "thousandsseparatorarabic" )
>     , ( 0x066d, "afii63167" )
>     , ( 0x0679, "afii57511" )
>     , ( 0x067e, "afii57506" )
>     , ( 0x0686, "afii57507" )
>     , ( 0x0688, "afii57512" )
>     , ( 0x0691, "afii57513" )
>     , ( 0x0698, "afii57508" )
>     , ( 0x06a4, "afii57505" )
>     , ( 0x06af, "afii57509" )
>     , ( 0x06ba, "afii57514" )
>     , ( 0x06c1, "haaltonearabic" )
>     , ( 0x06d1, "yehthreedotsbelowarabic" )
>     , ( 0x06d2, "afii57519" )
>     , ( 0x06d5, "afii57534" )
>     , ( 0x06f0, "zeropersian" )
>     , ( 0x06f1, "onepersian" )
>     , ( 0x06f2, "twopersian" )
>     , ( 0x06f3, "threepersian" )
>     , ( 0x06f4, "fourpersian" )
>     , ( 0x06f5, "fivepersian" )
>     , ( 0x06f6, "sixpersian" )
>     , ( 0x06f7, "sevenpersian" )
>     , ( 0x06f8, "eightpersian" )
>     , ( 0x06f9, "ninepersian" )
>     , ( 0x0901, "candrabindudeva" )
>     , ( 0x0902, "anusvaradeva" )
>     , ( 0x0903, "visargadeva" )
>     , ( 0x0905, "adeva" )
>     , ( 0x0906, "aadeva" )
>     , ( 0x0907, "ideva" )
>     , ( 0x0908, "iideva" )
>     , ( 0x0909, "udeva" )
>     , ( 0x090a, "uudeva" )
>     , ( 0x090b, "rvocalicdeva" )
>     , ( 0x090c, "lvocalicdeva" )
>     , ( 0x090d, "ecandradeva" )
>     , ( 0x090e, "eshortdeva" )
>     , ( 0x090f, "edeva" )
>     , ( 0x0910, "aideva" )
>     , ( 0x0911, "ocandradeva" )
>     , ( 0x0912, "oshortdeva" )
>     , ( 0x0913, "odeva" )
>     , ( 0x0914, "audeva" )
>     , ( 0x0915, "kadeva" )
>     , ( 0x0916, "khadeva" )
>     , ( 0x0917, "gadeva" )
>     , ( 0x0918, "ghadeva" )
>     , ( 0x0919, "ngadeva" )
>     , ( 0x091a, "cadeva" )
>     , ( 0x091b, "chadeva" )
>     , ( 0x091c, "jadeva" )
>     , ( 0x091d, "jhadeva" )
>     , ( 0x091e, "nyadeva" )
>     , ( 0x091f, "ttadeva" )
>     , ( 0x0920, "tthadeva" )
>     , ( 0x0921, "ddadeva" )
>     , ( 0x0922, "ddhadeva" )
>     , ( 0x0923, "nnadeva" )
>     , ( 0x0924, "tadeva" )
>     , ( 0x0925, "thadeva" )
>     , ( 0x0926, "dadeva" )
>     , ( 0x0927, "dhadeva" )
>     , ( 0x0928, "nadeva" )
>     , ( 0x0929, "nnnadeva" )
>     , ( 0x092a, "padeva" )
>     , ( 0x092b, "phadeva" )
>     , ( 0x092c, "badeva" )
>     , ( 0x092d, "bhadeva" )
>     , ( 0x092e, "madeva" )
>     , ( 0x092f, "yadeva" )
>     , ( 0x0930, "radeva" )
>     , ( 0x0931, "rradeva" )
>     , ( 0x0932, "ladeva" )
>     , ( 0x0933, "lladeva" )
>     , ( 0x0934, "llladeva" )
>     , ( 0x0935, "vadeva" )
>     , ( 0x0936, "shadeva" )
>     , ( 0x0937, "ssadeva" )
>     , ( 0x0938, "sadeva" )
>     , ( 0x0939, "hadeva" )
>     , ( 0x093c, "nuktadeva" )
>     , ( 0x093d, "avagrahadeva" )
>     , ( 0x093e, "aavowelsigndeva" )
>     , ( 0x093f, "ivowelsigndeva" )
>     , ( 0x0940, "iivowelsigndeva" )
>     , ( 0x0941, "uvowelsigndeva" )
>     , ( 0x0942, "uuvowelsigndeva" )
>     , ( 0x0943, "rvocalicvowelsigndeva" )
>     , ( 0x0944, "rrvocalicvowelsigndeva" )
>     , ( 0x0945, "ecandravowelsigndeva" )
>     , ( 0x0946, "eshortvowelsigndeva" )
>     , ( 0x0947, "evowelsigndeva" )
>     , ( 0x0948, "aivowelsigndeva" )
>     , ( 0x0949, "ocandravowelsigndeva" )
>     , ( 0x094a, "oshortvowelsigndeva" )
>     , ( 0x094b, "ovowelsigndeva" )
>     , ( 0x094c, "auvowelsigndeva" )
>     , ( 0x094d, "viramadeva" )
>     , ( 0x0950, "omdeva" )
>     , ( 0x0951, "udattadeva" )
>     , ( 0x0952, "anudattadeva" )
>     , ( 0x0953, "gravedeva" )
>     , ( 0x0954, "acutedeva" )
>     , ( 0x0958, "qadeva" )
>     , ( 0x0959, "khhadeva" )
>     , ( 0x095a, "ghhadeva" )
>     , ( 0x095b, "zadeva" )
>     , ( 0x095c, "dddhadeva" )
>     , ( 0x095d, "rhadeva" )
>     , ( 0x095e, "fadeva" )
>     , ( 0x095f, "yyadeva" )
>     , ( 0x0960, "rrvocalicdeva" )
>     , ( 0x0961, "llvocalicdeva" )
>     , ( 0x0962, "lvocalicvowelsigndeva" )
>     , ( 0x0963, "llvocalicvowelsigndeva" )
>     , ( 0x0964, "danda" )
>     , ( 0x0965, "dbldanda" )
>     , ( 0x0966, "zerodeva" )
>     , ( 0x0967, "onedeva" )
>     , ( 0x0968, "twodeva" )
>     , ( 0x0969, "threedeva" )
>     , ( 0x096a, "fourdeva" )
>     , ( 0x096b, "fivedeva" )
>     , ( 0x096c, "sixdeva" )
>     , ( 0x096d, "sevendeva" )
>     , ( 0x096e, "eightdeva" )
>     , ( 0x096f, "ninedeva" )
>     , ( 0x0970, "abbreviationsigndeva" )
>     , ( 0x0981, "candrabindubengali" )
>     , ( 0x0982, "anusvarabengali" )
>     , ( 0x0983, "visargabengali" )
>     , ( 0x0985, "abengali" )
>     , ( 0x0986, "aabengali" )
>     , ( 0x0987, "ibengali" )
>     , ( 0x0988, "iibengali" )
>     , ( 0x0989, "ubengali" )
>     , ( 0x098a, "uubengali" )
>     , ( 0x098b, "rvocalicbengali" )
>     , ( 0x098c, "lvocalicbengali" )
>     , ( 0x098f, "ebengali" )
>     , ( 0x0990, "aibengali" )
>     , ( 0x0993, "obengali" )
>     , ( 0x0994, "aubengali" )
>     , ( 0x0995, "kabengali" )
>     , ( 0x0996, "khabengali" )
>     , ( 0x0997, "gabengali" )
>     , ( 0x0998, "ghabengali" )
>     , ( 0x0999, "ngabengali" )
>     , ( 0x099a, "cabengali" )
>     , ( 0x099b, "chabengali" )
>     , ( 0x099c, "jabengali" )
>     , ( 0x099d, "jhabengali" )
>     , ( 0x099e, "nyabengali" )
>     , ( 0x099f, "ttabengali" )
>     , ( 0x09a0, "tthabengali" )
>     , ( 0x09a1, "ddabengali" )
>     , ( 0x09a2, "ddhabengali" )
>     , ( 0x09a3, "nnabengali" )
>     , ( 0x09a4, "tabengali" )
>     , ( 0x09a5, "thabengali" )
>     , ( 0x09a6, "dabengali" )
>     , ( 0x09a7, "dhabengali" )
>     , ( 0x09a8, "nabengali" )
>     , ( 0x09aa, "pabengali" )
>     , ( 0x09ab, "phabengali" )
>     , ( 0x09ac, "babengali" )
>     , ( 0x09ad, "bhabengali" )
>     , ( 0x09ae, "mabengali" )
>     , ( 0x09af, "yabengali" )
>     , ( 0x09b0, "rabengali" )
>     , ( 0x09b2, "labengali" )
>     , ( 0x09b6, "shabengali" )
>     , ( 0x09b7, "ssabengali" )
>     , ( 0x09b8, "sabengali" )
>     , ( 0x09b9, "habengali" )
>     , ( 0x09bc, "nuktabengali" )
>     , ( 0x09be, "aavowelsignbengali" )
>     , ( 0x09bf, "ivowelsignbengali" )
>     , ( 0x09c0, "iivowelsignbengali" )
>     , ( 0x09c1, "uvowelsignbengali" )
>     , ( 0x09c2, "uuvowelsignbengali" )
>     , ( 0x09c3, "rvocalicvowelsignbengali" )
>     , ( 0x09c4, "rrvocalicvowelsignbengali" )
>     , ( 0x09c7, "evowelsignbengali" )
>     , ( 0x09c8, "aivowelsignbengali" )
>     , ( 0x09cb, "ovowelsignbengali" )
>     , ( 0x09cc, "auvowelsignbengali" )
>     , ( 0x09cd, "viramabengali" )
>     , ( 0x09d7, "aulengthmarkbengali" )
>     , ( 0x09dc, "rrabengali" )
>     , ( 0x09dd, "rhabengali" )
>     , ( 0x09df, "yyabengali" )
>     , ( 0x09e0, "rrvocalicbengali" )
>     , ( 0x09e1, "llvocalicbengali" )
>     , ( 0x09e2, "lvocalicvowelsignbengali" )
>     , ( 0x09e3, "llvocalicvowelsignbengali" )
>     , ( 0x09e6, "zerobengali" )
>     , ( 0x09e7, "onebengali" )
>     , ( 0x09e8, "twobengali" )
>     , ( 0x09e9, "threebengali" )
>     , ( 0x09ea, "fourbengali" )
>     , ( 0x09eb, "fivebengali" )
>     , ( 0x09ec, "sixbengali" )
>     , ( 0x09ed, "sevenbengali" )
>     , ( 0x09ee, "eightbengali" )
>     , ( 0x09ef, "ninebengali" )
>     , ( 0x09f0, "ramiddlediagonalbengali" )
>     , ( 0x09f1, "ralowerdiagonalbengali" )
>     , ( 0x09f2, "rupeemarkbengali" )
>     , ( 0x09f3, "rupeesignbengali" )
>     , ( 0x09f4, "onenumeratorbengali" )
>     , ( 0x09f5, "twonumeratorbengali" )
>     , ( 0x09f6, "threenumeratorbengali" )
>     , ( 0x09f7, "fournumeratorbengali" )
>     , ( 0x09f8, "denominatorminusonenumeratorbengali" )
>     , ( 0x09f9, "sixteencurrencydenominatorbengali" )
>     , ( 0x09fa, "issharbengali" )
>     , ( 0x0a02, "bindigurmukhi" )
>     , ( 0x0a05, "agurmukhi" )
>     , ( 0x0a06, "aagurmukhi" )
>     , ( 0x0a07, "igurmukhi" )
>     , ( 0x0a08, "iigurmukhi" )
>     , ( 0x0a09, "ugurmukhi" )
>     , ( 0x0a0a, "uugurmukhi" )
>     , ( 0x0a0f, "eegurmukhi" )
>     , ( 0x0a10, "aigurmukhi" )
>     , ( 0x0a13, "oogurmukhi" )
>     , ( 0x0a14, "augurmukhi" )
>     , ( 0x0a15, "kagurmukhi" )
>     , ( 0x0a16, "khagurmukhi" )
>     , ( 0x0a17, "gagurmukhi" )
>     , ( 0x0a18, "ghagurmukhi" )
>     , ( 0x0a19, "ngagurmukhi" )
>     , ( 0x0a1a, "cagurmukhi" )
>     , ( 0x0a1b, "chagurmukhi" )
>     , ( 0x0a1c, "jagurmukhi" )
>     , ( 0x0a1d, "jhagurmukhi" )
>     , ( 0x0a1e, "nyagurmukhi" )
>     , ( 0x0a1f, "ttagurmukhi" )
>     , ( 0x0a20, "tthagurmukhi" )
>     , ( 0x0a21, "ddagurmukhi" )
>     , ( 0x0a22, "ddhagurmukhi" )
>     , ( 0x0a23, "nnagurmukhi" )
>     , ( 0x0a24, "tagurmukhi" )
>     , ( 0x0a25, "thagurmukhi" )
>     , ( 0x0a26, "dagurmukhi" )
>     , ( 0x0a27, "dhagurmukhi" )
>     , ( 0x0a28, "nagurmukhi" )
>     , ( 0x0a2a, "pagurmukhi" )
>     , ( 0x0a2b, "phagurmukhi" )
>     , ( 0x0a2c, "bagurmukhi" )
>     , ( 0x0a2d, "bhagurmukhi" )
>     , ( 0x0a2e, "magurmukhi" )
>     , ( 0x0a2f, "yagurmukhi" )
>     , ( 0x0a30, "ragurmukhi" )
>     , ( 0x0a32, "lagurmukhi" )
>     , ( 0x0a35, "vagurmukhi" )
>     , ( 0x0a36, "shagurmukhi" )
>     , ( 0x0a38, "sagurmukhi" )
>     , ( 0x0a39, "hagurmukhi" )
>     , ( 0x0a3c, "nuktagurmukhi" )
>     , ( 0x0a3e, "aamatragurmukhi" )
>     , ( 0x0a3f, "imatragurmukhi" )
>     , ( 0x0a40, "iimatragurmukhi" )
>     , ( 0x0a41, "umatragurmukhi" )
>     , ( 0x0a42, "uumatragurmukhi" )
>     , ( 0x0a47, "eematragurmukhi" )
>     , ( 0x0a48, "aimatragurmukhi" )
>     , ( 0x0a4b, "oomatragurmukhi" )
>     , ( 0x0a4c, "aumatragurmukhi" )
>     , ( 0x0a4d, "halantgurmukhi" )
>     , ( 0x0a59, "khhagurmukhi" )
>     , ( 0x0a5a, "ghhagurmukhi" )
>     , ( 0x0a5b, "zagurmukhi" )
>     , ( 0x0a5c, "rragurmukhi" )
>     , ( 0x0a5e, "fagurmukhi" )
>     , ( 0x0a66, "zerogurmukhi" )
>     , ( 0x0a67, "onegurmukhi" )
>     , ( 0x0a68, "twogurmukhi" )
>     , ( 0x0a69, "threegurmukhi" )
>     , ( 0x0a6a, "fourgurmukhi" )
>     , ( 0x0a6b, "fivegurmukhi" )
>     , ( 0x0a6c, "sixgurmukhi" )
>     , ( 0x0a6d, "sevengurmukhi" )
>     , ( 0x0a6e, "eightgurmukhi" )
>     , ( 0x0a6f, "ninegurmukhi" )
>     , ( 0x0a70, "tippigurmukhi" )
>     , ( 0x0a71, "addakgurmukhi" )
>     , ( 0x0a72, "irigurmukhi" )
>     , ( 0x0a73, "uragurmukhi" )
>     , ( 0x0a74, "ekonkargurmukhi" )
>     , ( 0x0a81, "candrabindugujarati" )
>     , ( 0x0a82, "anusvaragujarati" )
>     , ( 0x0a83, "visargagujarati" )
>     , ( 0x0a85, "agujarati" )
>     , ( 0x0a86, "aagujarati" )
>     , ( 0x0a87, "igujarati" )
>     , ( 0x0a88, "iigujarati" )
>     , ( 0x0a89, "ugujarati" )
>     , ( 0x0a8a, "uugujarati" )
>     , ( 0x0a8b, "rvocalicgujarati" )
>     , ( 0x0a8d, "ecandragujarati" )
>     , ( 0x0a8f, "egujarati" )
>     , ( 0x0a90, "aigujarati" )
>     , ( 0x0a91, "ocandragujarati" )
>     , ( 0x0a93, "ogujarati" )
>     , ( 0x0a94, "augujarati" )
>     , ( 0x0a95, "kagujarati" )
>     , ( 0x0a96, "khagujarati" )
>     , ( 0x0a97, "gagujarati" )
>     , ( 0x0a98, "ghagujarati" )
>     , ( 0x0a99, "ngagujarati" )
>     , ( 0x0a9a, "cagujarati" )
>     , ( 0x0a9b, "chagujarati" )
>     , ( 0x0a9c, "jagujarati" )
>     , ( 0x0a9d, "jhagujarati" )
>     , ( 0x0a9e, "nyagujarati" )
>     , ( 0x0a9f, "ttagujarati" )
>     , ( 0x0aa0, "tthagujarati" )
>     , ( 0x0aa1, "ddagujarati" )
>     , ( 0x0aa2, "ddhagujarati" )
>     , ( 0x0aa3, "nnagujarati" )
>     , ( 0x0aa4, "tagujarati" )
>     , ( 0x0aa5, "thagujarati" )
>     , ( 0x0aa6, "dagujarati" )
>     , ( 0x0aa7, "dhagujarati" )
>     , ( 0x0aa8, "nagujarati" )
>     , ( 0x0aaa, "pagujarati" )
>     , ( 0x0aab, "phagujarati" )
>     , ( 0x0aac, "bagujarati" )
>     , ( 0x0aad, "bhagujarati" )
>     , ( 0x0aae, "magujarati" )
>     , ( 0x0aaf, "yagujarati" )
>     , ( 0x0ab0, "ragujarati" )
>     , ( 0x0ab2, "lagujarati" )
>     , ( 0x0ab3, "llagujarati" )
>     , ( 0x0ab5, "vagujarati" )
>     , ( 0x0ab6, "shagujarati" )
>     , ( 0x0ab7, "ssagujarati" )
>     , ( 0x0ab8, "sagujarati" )
>     , ( 0x0ab9, "hagujarati" )
>     , ( 0x0abc, "nuktagujarati" )
>     , ( 0x0abe, "aavowelsigngujarati" )
>     , ( 0x0abf, "ivowelsigngujarati" )
>     , ( 0x0ac0, "iivowelsigngujarati" )
>     , ( 0x0ac1, "uvowelsigngujarati" )
>     , ( 0x0ac2, "uuvowelsigngujarati" )
>     , ( 0x0ac3, "rvocalicvowelsigngujarati" )
>     , ( 0x0ac4, "rrvocalicvowelsigngujarati" )
>     , ( 0x0ac5, "ecandravowelsigngujarati" )
>     , ( 0x0ac7, "evowelsigngujarati" )
>     , ( 0x0ac8, "aivowelsigngujarati" )
>     , ( 0x0ac9, "ocandravowelsigngujarati" )
>     , ( 0x0acb, "ovowelsigngujarati" )
>     , ( 0x0acc, "auvowelsigngujarati" )
>     , ( 0x0acd, "viramagujarati" )
>     , ( 0x0ad0, "omgujarati" )
>     , ( 0x0ae0, "rrvocalicgujarati" )
>     , ( 0x0ae6, "zerogujarati" )
>     , ( 0x0ae7, "onegujarati" )
>     , ( 0x0ae8, "twogujarati" )
>     , ( 0x0ae9, "threegujarati" )
>     , ( 0x0aea, "fourgujarati" )
>     , ( 0x0aeb, "fivegujarati" )
>     , ( 0x0aec, "sixgujarati" )
>     , ( 0x0aed, "sevengujarati" )
>     , ( 0x0aee, "eightgujarati" )
>     , ( 0x0aef, "ninegujarati" )
>     , ( 0x0e01, "kokaithai" )
>     , ( 0x0e02, "khokhaithai" )
>     , ( 0x0e03, "khokhuatthai" )
>     , ( 0x0e04, "khokhwaithai" )
>     , ( 0x0e05, "khokhonthai" )
>     , ( 0x0e06, "khorakhangthai" )
>     , ( 0x0e07, "ngonguthai" )
>     , ( 0x0e08, "chochanthai" )
>     , ( 0x0e09, "chochingthai" )
>     , ( 0x0e0a, "chochangthai" )
>     , ( 0x0e0b, "sosothai" )
>     , ( 0x0e0c, "chochoethai" )
>     , ( 0x0e0d, "yoyingthai" )
>     , ( 0x0e0e, "dochadathai" )
>     , ( 0x0e0f, "topatakthai" )
>     , ( 0x0e10, "thothanthai" )
>     , ( 0x0e11, "thonangmonthothai" )
>     , ( 0x0e12, "thophuthaothai" )
>     , ( 0x0e13, "nonenthai" )
>     , ( 0x0e14, "dodekthai" )
>     , ( 0x0e15, "totaothai" )
>     , ( 0x0e16, "thothungthai" )
>     , ( 0x0e17, "thothahanthai" )
>     , ( 0x0e18, "thothongthai" )
>     , ( 0x0e19, "nonuthai" )
>     , ( 0x0e1a, "bobaimaithai" )
>     , ( 0x0e1b, "poplathai" )
>     , ( 0x0e1c, "phophungthai" )
>     , ( 0x0e1d, "fofathai" )
>     , ( 0x0e1e, "phophanthai" )
>     , ( 0x0e1f, "fofanthai" )
>     , ( 0x0e20, "phosamphaothai" )
>     , ( 0x0e21, "momathai" )
>     , ( 0x0e22, "yoyakthai" )
>     , ( 0x0e23, "roruathai" )
>     , ( 0x0e24, "ruthai" )
>     , ( 0x0e25, "lolingthai" )
>     , ( 0x0e26, "luthai" )
>     , ( 0x0e27, "wowaenthai" )
>     , ( 0x0e28, "sosalathai" )
>     , ( 0x0e29, "sorusithai" )
>     , ( 0x0e2a, "sosuathai" )
>     , ( 0x0e2b, "hohipthai" )
>     , ( 0x0e2c, "lochulathai" )
>     , ( 0x0e2d, "oangthai" )
>     , ( 0x0e2e, "honokhukthai" )
>     , ( 0x0e2f, "paiyannoithai" )
>     , ( 0x0e30, "saraathai" )
>     , ( 0x0e31, "maihanakatthai" )
>     , ( 0x0e32, "saraaathai" )
>     , ( 0x0e33, "saraamthai" )
>     , ( 0x0e34, "saraithai" )
>     , ( 0x0e35, "saraiithai" )
>     , ( 0x0e36, "sarauethai" )
>     , ( 0x0e37, "saraueethai" )
>     , ( 0x0e38, "sarauthai" )
>     , ( 0x0e39, "sarauuthai" )
>     , ( 0x0e3a, "phinthuthai" )
>     , ( 0x0e3f, "bahtthai" )
>     , ( 0x0e40, "saraethai" )
>     , ( 0x0e41, "saraaethai" )
>     , ( 0x0e42, "saraothai" )
>     , ( 0x0e43, "saraaimaimuanthai" )
>     , ( 0x0e44, "saraaimaimalaithai" )
>     , ( 0x0e45, "lakkhangyaothai" )
>     , ( 0x0e46, "maiyamokthai" )
>     , ( 0x0e47, "maitaikhuthai" )
>     , ( 0x0e48, "maiekthai" )
>     , ( 0x0e49, "maithothai" )
>     , ( 0x0e4a, "maitrithai" )
>     , ( 0x0e4b, "maichattawathai" )
>     , ( 0x0e4c, "thanthakhatthai" )
>     , ( 0x0e4d, "nikhahitthai" )
>     , ( 0x0e4e, "yamakkanthai" )
>     , ( 0x0e4f, "fongmanthai" )
>     , ( 0x0e50, "zerothai" )
>     , ( 0x0e51, "onethai" )
>     , ( 0x0e52, "twothai" )
>     , ( 0x0e53, "threethai" )
>     , ( 0x0e54, "fourthai" )
>     , ( 0x0e55, "fivethai" )
>     , ( 0x0e56, "sixthai" )
>     , ( 0x0e57, "seventhai" )
>     , ( 0x0e58, "eightthai" )
>     , ( 0x0e59, "ninethai" )
>     , ( 0x0e5a, "angkhankhuthai" )
>     , ( 0x0e5b, "khomutthai" )
>     , ( 0x1e00, "Aringbelow" )
>     , ( 0x1e01, "aringbelow" )
>     , ( 0x1e02, "Bdotaccent" )
>     , ( 0x1e03, "bdotaccent" )
>     , ( 0x1e04, "Bdotbelow" )
>     , ( 0x1e05, "bdotbelow" )
>     , ( 0x1e06, "Blinebelow" )
>     , ( 0x1e07, "blinebelow" )
>     , ( 0x1e08, "Ccedillaacute" )
>     , ( 0x1e09, "ccedillaacute" )
>     , ( 0x1e0a, "Ddotaccent" )
>     , ( 0x1e0b, "ddotaccent" )
>     , ( 0x1e0c, "Ddotbelow" )
>     , ( 0x1e0d, "ddotbelow" )
>     , ( 0x1e0e, "Dlinebelow" )
>     , ( 0x1e0f, "dlinebelow" )
>     , ( 0x1e10, "Dcedilla" )
>     , ( 0x1e11, "dcedilla" )
>     , ( 0x1e12, "Dcircumflexbelow" )
>     , ( 0x1e13, "dcircumflexbelow" )
>     , ( 0x1e14, "Emacrongrave" )
>     , ( 0x1e15, "emacrongrave" )
>     , ( 0x1e16, "Emacronacute" )
>     , ( 0x1e17, "emacronacute" )
>     , ( 0x1e18, "Ecircumflexbelow" )
>     , ( 0x1e19, "ecircumflexbelow" )
>     , ( 0x1e1a, "Etildebelow" )
>     , ( 0x1e1b, "etildebelow" )
>     , ( 0x1e1c, "Ecedillabreve" )
>     , ( 0x1e1d, "ecedillabreve" )
>     , ( 0x1e1e, "Fdotaccent" )
>     , ( 0x1e1f, "fdotaccent" )
>     , ( 0x1e20, "Gmacron" )
>     , ( 0x1e21, "gmacron" )
>     , ( 0x1e22, "Hdotaccent" )
>     , ( 0x1e23, "hdotaccent" )
>     , ( 0x1e24, "Hdotbelow" )
>     , ( 0x1e25, "hdotbelow" )
>     , ( 0x1e26, "Hdieresis" )
>     , ( 0x1e27, "hdieresis" )
>     , ( 0x1e28, "Hcedilla" )
>     , ( 0x1e29, "hcedilla" )
>     , ( 0x1e2a, "Hbrevebelow" )
>     , ( 0x1e2b, "hbrevebelow" )
>     , ( 0x1e2c, "Itildebelow" )
>     , ( 0x1e2d, "itildebelow" )
>     , ( 0x1e2e, "Idieresisacute" )
>     , ( 0x1e2f, "idieresisacute" )
>     , ( 0x1e30, "Kacute" )
>     , ( 0x1e31, "kacute" )
>     , ( 0x1e32, "Kdotbelow" )
>     , ( 0x1e33, "kdotbelow" )
>     , ( 0x1e34, "Klinebelow" )
>     , ( 0x1e35, "klinebelow" )
>     , ( 0x1e36, "Ldotbelow" )
>     , ( 0x1e37, "ldotbelow" )
>     , ( 0x1e38, "Ldotbelowmacron" )
>     , ( 0x1e39, "ldotbelowmacron" )
>     , ( 0x1e3a, "Llinebelow" )
>     , ( 0x1e3b, "llinebelow" )
>     , ( 0x1e3c, "Lcircumflexbelow" )
>     , ( 0x1e3d, "lcircumflexbelow" )
>     , ( 0x1e3e, "Macute" )
>     , ( 0x1e3f, "macute" )
>     , ( 0x1e40, "Mdotaccent" )
>     , ( 0x1e41, "mdotaccent" )
>     , ( 0x1e42, "Mdotbelow" )
>     , ( 0x1e43, "mdotbelow" )
>     , ( 0x1e44, "Ndotaccent" )
>     , ( 0x1e45, "ndotaccent" )
>     , ( 0x1e46, "Ndotbelow" )
>     , ( 0x1e47, "ndotbelow" )
>     , ( 0x1e48, "Nlinebelow" )
>     , ( 0x1e49, "nlinebelow" )
>     , ( 0x1e4a, "Ncircumflexbelow" )
>     , ( 0x1e4b, "ncircumflexbelow" )
>     , ( 0x1e4c, "Otildeacute" )
>     , ( 0x1e4d, "otildeacute" )
>     , ( 0x1e4e, "Otildedieresis" )
>     , ( 0x1e4f, "otildedieresis" )
>     , ( 0x1e50, "Omacrongrave" )
>     , ( 0x1e51, "omacrongrave" )
>     , ( 0x1e52, "Omacronacute" )
>     , ( 0x1e53, "omacronacute" )
>     , ( 0x1e54, "Pacute" )
>     , ( 0x1e55, "pacute" )
>     , ( 0x1e56, "Pdotaccent" )
>     , ( 0x1e57, "pdotaccent" )
>     , ( 0x1e58, "Rdotaccent" )
>     , ( 0x1e59, "rdotaccent" )
>     , ( 0x1e5a, "Rdotbelow" )
>     , ( 0x1e5b, "rdotbelow" )
>     , ( 0x1e5c, "Rdotbelowmacron" )
>     , ( 0x1e5d, "rdotbelowmacron" )
>     , ( 0x1e5e, "Rlinebelow" )
>     , ( 0x1e5f, "rlinebelow" )
>     , ( 0x1e60, "Sdotaccent" )
>     , ( 0x1e61, "sdotaccent" )
>     , ( 0x1e62, "Sdotbelow" )
>     , ( 0x1e63, "sdotbelow" )
>     , ( 0x1e64, "Sacutedotaccent" )
>     , ( 0x1e65, "sacutedotaccent" )
>     , ( 0x1e66, "Scarondotaccent" )
>     , ( 0x1e67, "scarondotaccent" )
>     , ( 0x1e68, "Sdotbelowdotaccent" )
>     , ( 0x1e69, "sdotbelowdotaccent" )
>     , ( 0x1e6a, "Tdotaccent" )
>     , ( 0x1e6b, "tdotaccent" )
>     , ( 0x1e6c, "Tdotbelow" )
>     , ( 0x1e6d, "tdotbelow" )
>     , ( 0x1e6e, "Tlinebelow" )
>     , ( 0x1e6f, "tlinebelow" )
>     , ( 0x1e70, "Tcircumflexbelow" )
>     , ( 0x1e71, "tcircumflexbelow" )
>     , ( 0x1e72, "Udieresisbelow" )
>     , ( 0x1e73, "udieresisbelow" )
>     , ( 0x1e74, "Utildebelow" )
>     , ( 0x1e75, "utildebelow" )
>     , ( 0x1e76, "Ucircumflexbelow" )
>     , ( 0x1e77, "ucircumflexbelow" )
>     , ( 0x1e78, "Utildeacute" )
>     , ( 0x1e79, "utildeacute" )
>     , ( 0x1e7a, "Umacrondieresis" )
>     , ( 0x1e7b, "umacrondieresis" )
>     , ( 0x1e7c, "Vtilde" )
>     , ( 0x1e7d, "vtilde" )
>     , ( 0x1e7e, "Vdotbelow" )
>     , ( 0x1e7f, "vdotbelow" )
>     , ( 0x1e80, "Wgrave" )
>     , ( 0x1e81, "wgrave" )
>     , ( 0x1e82, "Wacute" )
>     , ( 0x1e83, "wacute" )
>     , ( 0x1e84, "Wdieresis" )
>     , ( 0x1e85, "wdieresis" )
>     , ( 0x1e86, "Wdotaccent" )
>     , ( 0x1e87, "wdotaccent" )
>     , ( 0x1e88, "Wdotbelow" )
>     , ( 0x1e89, "wdotbelow" )
>     , ( 0x1e8a, "Xdotaccent" )
>     , ( 0x1e8b, "xdotaccent" )
>     , ( 0x1e8c, "Xdieresis" )
>     , ( 0x1e8d, "xdieresis" )
>     , ( 0x1e8e, "Ydotaccent" )
>     , ( 0x1e8f, "ydotaccent" )
>     , ( 0x1e90, "Zcircumflex" )
>     , ( 0x1e91, "zcircumflex" )
>     , ( 0x1e92, "Zdotbelow" )
>     , ( 0x1e93, "zdotbelow" )
>     , ( 0x1e94, "Zlinebelow" )
>     , ( 0x1e95, "zlinebelow" )
>     , ( 0x1e96, "hlinebelow" )
>     , ( 0x1e97, "tdieresis" )
>     , ( 0x1e98, "wring" )
>     , ( 0x1e99, "yring" )
>     , ( 0x1e9a, "arighthalfring" )
>     , ( 0x1e9b, "slongdotaccent" )
>     , ( 0x1ea0, "Adotbelow" )
>     , ( 0x1ea1, "adotbelow" )
>     , ( 0x1ea2, "Ahookabove" )
>     , ( 0x1ea3, "ahookabove" )
>     , ( 0x1ea4, "Acircumflexacute" )
>     , ( 0x1ea5, "acircumflexacute" )
>     , ( 0x1ea6, "Acircumflexgrave" )
>     , ( 0x1ea7, "acircumflexgrave" )
>     , ( 0x1ea8, "Acircumflexhookabove" )
>     , ( 0x1ea9, "acircumflexhookabove" )
>     , ( 0x1eaa, "Acircumflextilde" )
>     , ( 0x1eab, "acircumflextilde" )
>     , ( 0x1eac, "Acircumflexdotbelow" )
>     , ( 0x1ead, "acircumflexdotbelow" )
>     , ( 0x1eae, "Abreveacute" )
>     , ( 0x1eaf, "abreveacute" )
>     , ( 0x1eb0, "Abrevegrave" )
>     , ( 0x1eb1, "abrevegrave" )
>     , ( 0x1eb2, "Abrevehookabove" )
>     , ( 0x1eb3, "abrevehookabove" )
>     , ( 0x1eb4, "Abrevetilde" )
>     , ( 0x1eb5, "abrevetilde" )
>     , ( 0x1eb6, "Abrevedotbelow" )
>     , ( 0x1eb7, "abrevedotbelow" )
>     , ( 0x1eb8, "Edotbelow" )
>     , ( 0x1eb9, "edotbelow" )
>     , ( 0x1eba, "Ehookabove" )
>     , ( 0x1ebb, "ehookabove" )
>     , ( 0x1ebc, "Etilde" )
>     , ( 0x1ebd, "etilde" )
>     , ( 0x1ebe, "Ecircumflexacute" )
>     , ( 0x1ebf, "ecircumflexacute" )
>     , ( 0x1ec0, "Ecircumflexgrave" )
>     , ( 0x1ec1, "ecircumflexgrave" )
>     , ( 0x1ec2, "Ecircumflexhookabove" )
>     , ( 0x1ec3, "ecircumflexhookabove" )
>     , ( 0x1ec4, "Ecircumflextilde" )
>     , ( 0x1ec5, "ecircumflextilde" )
>     , ( 0x1ec6, "Ecircumflexdotbelow" )
>     , ( 0x1ec7, "ecircumflexdotbelow" )
>     , ( 0x1ec8, "Ihookabove" )
>     , ( 0x1ec9, "ihookabove" )
>     , ( 0x1eca, "Idotbelow" )
>     , ( 0x1ecb, "idotbelow" )
>     , ( 0x1ecc, "Odotbelow" )
>     , ( 0x1ecd, "odotbelow" )
>     , ( 0x1ece, "Ohookabove" )
>     , ( 0x1ecf, "ohookabove" )
>     , ( 0x1ed0, "Ocircumflexacute" )
>     , ( 0x1ed1, "ocircumflexacute" )
>     , ( 0x1ed2, "Ocircumflexgrave" )
>     , ( 0x1ed3, "ocircumflexgrave" )
>     , ( 0x1ed4, "Ocircumflexhookabove" )
>     , ( 0x1ed5, "ocircumflexhookabove" )
>     , ( 0x1ed6, "Ocircumflextilde" )
>     , ( 0x1ed7, "ocircumflextilde" )
>     , ( 0x1ed8, "Ocircumflexdotbelow" )
>     , ( 0x1ed9, "ocircumflexdotbelow" )
>     , ( 0x1eda, "Ohornacute" )
>     , ( 0x1edb, "ohornacute" )
>     , ( 0x1edc, "Ohorngrave" )
>     , ( 0x1edd, "ohorngrave" )
>     , ( 0x1ede, "Ohornhookabove" )
>     , ( 0x1edf, "ohornhookabove" )
>     , ( 0x1ee0, "Ohorntilde" )
>     , ( 0x1ee1, "ohorntilde" )
>     , ( 0x1ee2, "Ohorndotbelow" )
>     , ( 0x1ee3, "ohorndotbelow" )
>     , ( 0x1ee4, "Udotbelow" )
>     , ( 0x1ee5, "udotbelow" )
>     , ( 0x1ee6, "Uhookabove" )
>     , ( 0x1ee7, "uhookabove" )
>     , ( 0x1ee8, "Uhornacute" )
>     , ( 0x1ee9, "uhornacute" )
>     , ( 0x1eea, "Uhorngrave" )
>     , ( 0x1eeb, "uhorngrave" )
>     , ( 0x1eec, "Uhornhookabove" )
>     , ( 0x1eed, "uhornhookabove" )
>     , ( 0x1eee, "Uhorntilde" )
>     , ( 0x1eef, "uhorntilde" )
>     , ( 0x1ef0, "Uhorndotbelow" )
>     , ( 0x1ef1, "uhorndotbelow" )
>     , ( 0x1ef2, "Ygrave" )
>     , ( 0x1ef3, "ygrave" )
>     , ( 0x1ef4, "Ydotbelow" )
>     , ( 0x1ef5, "ydotbelow" )
>     , ( 0x1ef6, "Yhookabove" )
>     , ( 0x1ef7, "yhookabove" )
>     , ( 0x1ef8, "Ytilde" )
>     , ( 0x1ef9, "ytilde" )
>     , ( 0x2002, "enspace" )
>     , ( 0x200b, "zerowidthspace" )
>     , ( 0x200c, "afii61664" )
>     , ( 0x200d, "afii301" )
>     , ( 0x200e, "afii299" )
>     , ( 0x200f, "afii300" )
>     , ( 0x2010, "hyphentwo" )
>     , ( 0x2012, "figuredash" )
>     , ( 0x2013, "endash" )
>     , ( 0x2014, "emdash" )
>     , ( 0x2015, "afii00208" )
>     , ( 0x2016, "dblverticalbar" )
>     , ( 0x2017, "dbllowline" )
>     , ( 0x2018, "quoteleft" )
>     , ( 0x2019, "quoteright" )
>     , ( 0x201a, "quotesinglbase" )
>     , ( 0x201b, "quoteleftreversed" )
>     , ( 0x201c, "quotedblleft" )
>     , ( 0x201d, "quotedblright" )
>     , ( 0x201e, "quotedblbase" )
>     , ( 0x2020, "dagger" )
>     , ( 0x2021, "daggerdbl" )
>     , ( 0x2022, "bullet" )
>     , ( 0x2024, "onedotenleader" )
>     , ( 0x2025, "twodotenleader" )
>     , ( 0x2026, "ellipsis" )
>     , ( 0x202c, "afii61573" )
>     , ( 0x202d, "afii61574" )
>     , ( 0x202e, "afii61575" )
>     , ( 0x2030, "perthousand" )
>     , ( 0x2032, "minute" )
>     , ( 0x2033, "second" )
>     , ( 0x2035, "primereversed" )
>     , ( 0x2039, "guilsinglleft" )
>     , ( 0x203a, "guilsinglright" )
>     , ( 0x203b, "referencemark" )
>     , ( 0x203c, "exclamdbl" )
>     , ( 0x203e, "overline" )
>     , ( 0x2042, "asterism" )
>     , ( 0x2044, "fraction" )
>     , ( 0x2070, "zerosuperior" )
>     , ( 0x2074, "foursuperior" )
>     , ( 0x2075, "fivesuperior" )
>     , ( 0x2076, "sixsuperior" )
>     , ( 0x2077, "sevensuperior" )
>     , ( 0x2078, "eightsuperior" )
>     , ( 0x2079, "ninesuperior" )
>     , ( 0x207a, "plussuperior" )
>     , ( 0x207c, "equalsuperior" )
>     , ( 0x207d, "parenleftsuperior" )
>     , ( 0x207e, "parenrightsuperior" )
>     , ( 0x207f, "nsuperior" )
>     , ( 0x2080, "zeroinferior" )
>     , ( 0x2081, "oneinferior" )
>     , ( 0x2082, "twoinferior" )
>     , ( 0x2083, "threeinferior" )
>     , ( 0x2084, "fourinferior" )
>     , ( 0x2085, "fiveinferior" )
>     , ( 0x2086, "sixinferior" )
>     , ( 0x2087, "seveninferior" )
>     , ( 0x2088, "eightinferior" )
>     , ( 0x2089, "nineinferior" )
>     , ( 0x208d, "parenleftinferior" )
>     , ( 0x208e, "parenrightinferior" )
>     , ( 0x20a1, "colonmonetary" )
>     , ( 0x20a2, "cruzeiro" )
>     , ( 0x20a3, "franc" )
>     , ( 0x20a4, "afii08941" )
>     , ( 0x20a7, "peseta" )
>     , ( 0x20a9, "won" )
>     , ( 0x20aa, "afii57636" )
>     , ( 0x20ab, "dong" )
>     , ( 0x20ac, "Euro" )
>     , ( 0x2103, "centigrade" )
>     , ( 0x2105, "afii61248" )
>     , ( 0x2109, "fahrenheit" )
>     , ( 0x2111, "Ifraktur" )
>     , ( 0x2113, "afii61289" )
>     , ( 0x2116, "afii61352" )
>     , ( 0x2118, "weierstrass" )
>     , ( 0x211c, "Rfraktur" )
>     , ( 0x211e, "prescription" )
>     , ( 0x2121, "telephone" )
>     , ( 0x2122, "trademark" )
>     , ( 0x2126, "Ohm" )
>     , ( 0x212b, "angstrom" )
>     , ( 0x212e, "estimated" )
>     , ( 0x2135, "aleph" )
>     , ( 0x2153, "onethird" )
>     , ( 0x2154, "twothirds" )
>     , ( 0x215b, "oneeighth" )
>     , ( 0x215c, "threeeighths" )
>     , ( 0x215d, "fiveeighths" )
>     , ( 0x215e, "seveneighths" )
>     , ( 0x2160, "Oneroman" )
>     , ( 0x2161, "Tworoman" )
>     , ( 0x2162, "Threeroman" )
>     , ( 0x2163, "Fourroman" )
>     , ( 0x2164, "Fiveroman" )
>     , ( 0x2165, "Sixroman" )
>     , ( 0x2166, "Sevenroman" )
>     , ( 0x2167, "Eightroman" )
>     , ( 0x2168, "Nineroman" )
>     , ( 0x2169, "Tenroman" )
>     , ( 0x216a, "Elevenroman" )
>     , ( 0x216b, "Twelveroman" )
>     , ( 0x2170, "oneroman" )
>     , ( 0x2171, "tworoman" )
>     , ( 0x2172, "threeroman" )
>     , ( 0x2173, "fourroman" )
>     , ( 0x2174, "fiveroman" )
>     , ( 0x2175, "sixroman" )
>     , ( 0x2176, "sevenroman" )
>     , ( 0x2177, "eightroman" )
>     , ( 0x2178, "nineroman" )
>     , ( 0x2179, "tenroman" )
>     , ( 0x217a, "elevenroman" )
>     , ( 0x217b, "twelveroman" )
>     , ( 0x2190, "arrowleft" )
>     , ( 0x2191, "arrowup" )
>     , ( 0x2192, "arrowright" )
>     , ( 0x2193, "arrowdown" )
>     , ( 0x2194, "arrowboth" )
>     , ( 0x2195, "arrowupdn" )
>     , ( 0x2196, "arrowupleft" )
>     , ( 0x2197, "arrowupright" )
>     , ( 0x2198, "arrowdownright" )
>     , ( 0x2199, "arrowdownleft" )
>     , ( 0x21a8, "arrowupdnbse" )
>     , ( 0x21b5, "carriagereturn" )
>     , ( 0x21bc, "harpoonleftbarbup" )
>     , ( 0x21c0, "harpoonrightbarbup" )
>     , ( 0x21c4, "arrowrightoverleft" )
>     , ( 0x21c5, "arrowupleftofdown" )
>     , ( 0x21c6, "arrowleftoverright" )
>     , ( 0x21cd, "arrowleftdblstroke" )
>     , ( 0x21cf, "arrowrightdblstroke" )
>     , ( 0x21d0, "arrowdblleft" )
>     , ( 0x21d1, "arrowdblup" )
>     , ( 0x21d2, "arrowdblright" )
>     , ( 0x21d3, "arrowdbldown" )
>     , ( 0x21d4, "arrowdblboth" )
>     , ( 0x21de, "pageup" )
>     , ( 0x21df, "pagedown" )
>     , ( 0x21e0, "arrowdashleft" )
>     , ( 0x21e1, "arrowdashup" )
>     , ( 0x21e2, "arrowdashright" )
>     , ( 0x21e3, "arrowdashdown" )
>     , ( 0x21e4, "arrowtableft" )
>     , ( 0x21e5, "arrowtabright" )
>     , ( 0x21e6, "arrowleftwhite" )
>     , ( 0x21e7, "arrowupwhite" )
>     , ( 0x21e8, "arrowrightwhite" )
>     , ( 0x21e9, "arrowdownwhite" )
>     , ( 0x21ea, "capslock" )
>     , ( 0x2200, "forall" )
>     , ( 0x2202, "partialdiff" )
>     , ( 0x2203, "existential" )
>     , ( 0x2205, "emptyset" )
>     , ( 0x2206, "Delta" )
>     , ( 0x2207, "gradient" )
>     , ( 0x2208, "element" )
>     , ( 0x2209, "notelement" )
>     , ( 0x220b, "suchthat" )
>     , ( 0x220c, "notcontains" )
>     , ( 0x220f, "product" )
>     , ( 0x2211, "summation" )
>     , ( 0x2212, "minus" )
>     , ( 0x2213, "minusplus" )
>     , ( 0x2215, "divisionslash" )
>     , ( 0x2217, "asteriskmath" )
>     , ( 0x2219, "bulletoperator" )
>     , ( 0x221a, "radical" )
>     , ( 0x221d, "proportional" )
>     , ( 0x221e, "infinity" )
>     , ( 0x221f, "orthogonal" )
>     , ( 0x2220, "angle" )
>     , ( 0x2223, "divides" )
>     , ( 0x2225, "parallel" )
>     , ( 0x2226, "notparallel" )
>     , ( 0x2227, "logicaland" )
>     , ( 0x2228, "logicalor" )
>     , ( 0x2229, "intersection" )
>     , ( 0x222a, "union" )
>     , ( 0x222b, "integral" )
>     , ( 0x222c, "dblintegral" )
>     , ( 0x222e, "contourintegral" )
>     , ( 0x2234, "therefore" )
>     , ( 0x2235, "because" )
>     , ( 0x2236, "ratio" )
>     , ( 0x2237, "proportion" )
>     , ( 0x223c, "similar" )
>     , ( 0x223d, "reversedtilde" )
>     , ( 0x2243, "asymptoticallyequal" )
>     , ( 0x2245, "approximatelyequal" )
>     , ( 0x2248, "approxequal" )
>     , ( 0x224c, "allequal" )
>     , ( 0x2250, "approaches" )
>     , ( 0x2251, "geometricallyequal" )
>     , ( 0x2252, "approxequalorimage" )
>     , ( 0x2253, "imageorapproximatelyequal" )
>     , ( 0x2260, "notequal" )
>     , ( 0x2261, "equivalence" )
>     , ( 0x2262, "notidentical" )
>     , ( 0x2264, "lessequal" )
>     , ( 0x2265, "greaterequal" )
>     , ( 0x2266, "lessoverequal" )
>     , ( 0x2267, "greateroverequal" )
>     , ( 0x226a, "muchless" )
>     , ( 0x226b, "muchgreater" )
>     , ( 0x226e, "notless" )
>     , ( 0x226f, "notgreater" )
>     , ( 0x2270, "notlessnorequal" )
>     , ( 0x2271, "notgreaternorequal" )
>     , ( 0x2272, "lessorequivalent" )
>     , ( 0x2273, "greaterorequivalent" )
>     , ( 0x2276, "lessorgreater" )
>     , ( 0x2277, "greaterorless" )
>     , ( 0x2279, "notgreaternorless" )
>     , ( 0x227a, "precedes" )
>     , ( 0x227b, "succeeds" )
>     , ( 0x2280, "notprecedes" )
>     , ( 0x2281, "notsucceeds" )
>     , ( 0x2282, "propersubset" )
>     , ( 0x2283, "propersuperset" )
>     , ( 0x2284, "notsubset" )
>     , ( 0x2285, "notsuperset" )
>     , ( 0x2286, "reflexsubset" )
>     , ( 0x2287, "reflexsuperset" )
>     , ( 0x228a, "subsetnotequal" )
>     , ( 0x228b, "supersetnotequal" )
>     , ( 0x2295, "circleplus" )
>     , ( 0x2296, "minuscircle" )
>     , ( 0x2297, "circlemultiply" )
>     , ( 0x2299, "circleot" )
>     , ( 0x22a3, "tackleft" )
>     , ( 0x22a4, "tackdown" )
>     , ( 0x22a5, "perpendicular" )
>     , ( 0x22bf, "righttriangle" )
>     , ( 0x22c5, "dotmath" )
>     , ( 0x22ce, "curlyor" )
>     , ( 0x22cf, "curlyand" )
>     , ( 0x22da, "lessequalorgreater" )
>     , ( 0x22db, "greaterequalorless" )
>     , ( 0x22ee, "ellipsisvertical" )
>     , ( 0x2302, "house" )
>     , ( 0x2303, "control" )
>     , ( 0x2305, "projective" )
>     , ( 0x2310, "logicalnotreversed" )
>     , ( 0x2312, "arc" )
>     , ( 0x2318, "propellor" )
>     , ( 0x2320, "integraltop" )
>     , ( 0x2321, "integralbottom" )
>     , ( 0x2325, "option" )
>     , ( 0x2326, "deleteright" )
>     , ( 0x2327, "clear" )
>     , ( 0x2329, "angleleft" )
>     , ( 0x232a, "angleright" )
>     , ( 0x232b, "deleteleft" )
>     , ( 0x2423, "blank" )
>     , ( 0x2460, "onecircle" )
>     , ( 0x2461, "twocircle" )
>     , ( 0x2462, "threecircle" )
>     , ( 0x2463, "fourcircle" )
>     , ( 0x2464, "fivecircle" )
>     , ( 0x2465, "sixcircle" )
>     , ( 0x2466, "sevencircle" )
>     , ( 0x2467, "eightcircle" )
>     , ( 0x2468, "ninecircle" )
>     , ( 0x2469, "tencircle" )
>     , ( 0x246a, "elevencircle" )
>     , ( 0x246b, "twelvecircle" )
>     , ( 0x246c, "thirteencircle" )
>     , ( 0x246d, "fourteencircle" )
>     , ( 0x246e, "fifteencircle" )
>     , ( 0x246f, "sixteencircle" )
>     , ( 0x2470, "seventeencircle" )
>     , ( 0x2471, "eighteencircle" )
>     , ( 0x2472, "nineteencircle" )
>     , ( 0x2473, "twentycircle" )
>     , ( 0x2474, "oneparen" )
>     , ( 0x2475, "twoparen" )
>     , ( 0x2476, "threeparen" )
>     , ( 0x2477, "fourparen" )
>     , ( 0x2478, "fiveparen" )
>     , ( 0x2479, "sixparen" )
>     , ( 0x247a, "sevenparen" )
>     , ( 0x247b, "eightparen" )
>     , ( 0x247c, "nineparen" )
>     , ( 0x247d, "tenparen" )
>     , ( 0x247e, "elevenparen" )
>     , ( 0x247f, "twelveparen" )
>     , ( 0x2480, "thirteenparen" )
>     , ( 0x2481, "fourteenparen" )
>     , ( 0x2482, "fifteenparen" )
>     , ( 0x2483, "sixteenparen" )
>     , ( 0x2484, "seventeenparen" )
>     , ( 0x2485, "eighteenparen" )
>     , ( 0x2486, "nineteenparen" )
>     , ( 0x2487, "twentyparen" )
>     , ( 0x2488, "oneperiod" )
>     , ( 0x2489, "twoperiod" )
>     , ( 0x248a, "threeperiod" )
>     , ( 0x248b, "fourperiod" )
>     , ( 0x248c, "fiveperiod" )
>     , ( 0x248d, "sixperiod" )
>     , ( 0x248e, "sevenperiod" )
>     , ( 0x248f, "eightperiod" )
>     , ( 0x2490, "nineperiod" )
>     , ( 0x2491, "tenperiod" )
>     , ( 0x2492, "elevenperiod" )
>     , ( 0x2493, "twelveperiod" )
>     , ( 0x2494, "thirteenperiod" )
>     , ( 0x2495, "fourteenperiod" )
>     , ( 0x2496, "fifteenperiod" )
>     , ( 0x2497, "sixteenperiod" )
>     , ( 0x2498, "seventeenperiod" )
>     , ( 0x2499, "eighteenperiod" )
>     , ( 0x249a, "nineteenperiod" )
>     , ( 0x249b, "twentyperiod" )
>     , ( 0x249c, "aparen" )
>     , ( 0x249d, "bparen" )
>     , ( 0x249e, "cparen" )
>     , ( 0x249f, "dparen" )
>     , ( 0x24a0, "eparen" )
>     , ( 0x24a1, "fparen" )
>     , ( 0x24a2, "gparen" )
>     , ( 0x24a3, "hparen" )
>     , ( 0x24a4, "iparen" )
>     , ( 0x24a5, "jparen" )
>     , ( 0x24a6, "kparen" )
>     , ( 0x24a7, "lparen" )
>     , ( 0x24a8, "mparen" )
>     , ( 0x24a9, "nparen" )
>     , ( 0x24aa, "oparen" )
>     , ( 0x24ab, "pparen" )
>     , ( 0x24ac, "qparen" )
>     , ( 0x24ad, "rparen" )
>     , ( 0x24ae, "sparen" )
>     , ( 0x24af, "tparen" )
>     , ( 0x24b0, "uparen" )
>     , ( 0x24b1, "vparen" )
>     , ( 0x24b2, "wparen" )
>     , ( 0x24b3, "xparen" )
>     , ( 0x24b4, "yparen" )
>     , ( 0x24b5, "zparen" )
>     , ( 0x24b6, "Acircle" )
>     , ( 0x24b7, "Bcircle" )
>     , ( 0x24b8, "Ccircle" )
>     , ( 0x24b9, "Dcircle" )
>     , ( 0x24ba, "Ecircle" )
>     , ( 0x24bb, "Fcircle" )
>     , ( 0x24bc, "Gcircle" )
>     , ( 0x24bd, "Hcircle" )
>     , ( 0x24be, "Icircle" )
>     , ( 0x24bf, "Jcircle" )
>     , ( 0x24c0, "Kcircle" )
>     , ( 0x24c1, "Lcircle" )
>     , ( 0x24c2, "Mcircle" )
>     , ( 0x24c3, "Ncircle" )
>     , ( 0x24c4, "Ocircle" )
>     , ( 0x24c5, "Pcircle" )
>     , ( 0x24c6, "Qcircle" )
>     , ( 0x24c7, "Rcircle" )
>     , ( 0x24c8, "Scircle" )
>     , ( 0x24c9, "Tcircle" )
>     , ( 0x24ca, "Ucircle" )
>     , ( 0x24cb, "Vcircle" )
>     , ( 0x24cc, "Wcircle" )
>     , ( 0x24cd, "Xcircle" )
>     , ( 0x24ce, "Ycircle" )
>     , ( 0x24cf, "Zcircle" )
>     , ( 0x24d0, "acircle" )
>     , ( 0x24d1, "bcircle" )
>     , ( 0x24d2, "ccircle" )
>     , ( 0x24d3, "dcircle" )
>     , ( 0x24d4, "ecircle" )
>     , ( 0x24d5, "fcircle" )
>     , ( 0x24d6, "gcircle" )
>     , ( 0x24d7, "hcircle" )
>     , ( 0x24d8, "icircle" )
>     , ( 0x24d9, "jcircle" )
>     , ( 0x24da, "kcircle" )
>     , ( 0x24db, "lcircle" )
>     , ( 0x24dc, "mcircle" )
>     , ( 0x24dd, "ncircle" )
>     , ( 0x24de, "ocircle" )
>     , ( 0x24df, "pcircle" )
>     , ( 0x24e0, "qcircle" )
>     , ( 0x24e1, "rcircle" )
>     , ( 0x24e2, "scircle" )
>     , ( 0x24e3, "tcircle" )
>     , ( 0x24e4, "ucircle" )
>     , ( 0x24e5, "vcircle" )
>     , ( 0x24e6, "wcircle" )
>     , ( 0x24e7, "xcircle" )
>     , ( 0x24e8, "ycircle" )
>     , ( 0x24e9, "zcircle" )
>     , ( 0x2500, "SF100000" )
>     , ( 0x2502, "SF110000" )
>     , ( 0x250c, "SF010000" )
>     , ( 0x2510, "SF030000" )
>     , ( 0x2514, "SF020000" )
>     , ( 0x2518, "SF040000" )
>     , ( 0x251c, "SF080000" )
>     , ( 0x2524, "SF090000" )
>     , ( 0x252c, "SF060000" )
>     , ( 0x2534, "SF070000" )
>     , ( 0x253c, "SF050000" )
>     , ( 0x2550, "SF430000" )
>     , ( 0x2551, "SF240000" )
>     , ( 0x2552, "SF510000" )
>     , ( 0x2553, "SF520000" )
>     , ( 0x2554, "SF390000" )
>     , ( 0x2555, "SF220000" )
>     , ( 0x2556, "SF210000" )
>     , ( 0x2557, "SF250000" )
>     , ( 0x2558, "SF500000" )
>     , ( 0x2559, "SF490000" )
>     , ( 0x255a, "SF380000" )
>     , ( 0x255b, "SF280000" )
>     , ( 0x255c, "SF270000" )
>     , ( 0x255d, "SF260000" )
>     , ( 0x255e, "SF360000" )
>     , ( 0x255f, "SF370000" )
>     , ( 0x2560, "SF420000" )
>     , ( 0x2561, "SF190000" )
>     , ( 0x2562, "SF200000" )
>     , ( 0x2563, "SF230000" )
>     , ( 0x2564, "SF470000" )
>     , ( 0x2565, "SF480000" )
>     , ( 0x2566, "SF410000" )
>     , ( 0x2567, "SF450000" )
>     , ( 0x2568, "SF460000" )
>     , ( 0x2569, "SF400000" )
>     , ( 0x256a, "SF540000" )
>     , ( 0x256b, "SF530000" )
>     , ( 0x256c, "SF440000" )
>     , ( 0x2580, "upblock" )
>     , ( 0x2584, "dnblock" )
>     , ( 0x2588, "block" )
>     , ( 0x258c, "lfblock" )
>     , ( 0x2590, "rtblock" )
>     , ( 0x2591, "ltshade" )
>     , ( 0x2592, "shade" )
>     , ( 0x2593, "dkshade" )
>     , ( 0x25a0, "blacksquare" )
>     , ( 0x25a1, "H22073" )
>     , ( 0x25a3, "squarewhitewithsmallblack" )
>     , ( 0x25a4, "squarehorizontalfill" )
>     , ( 0x25a5, "squareverticalfill" )
>     , ( 0x25a6, "squareorthogonalcrosshatchfill" )
>     , ( 0x25a7, "squareupperlefttolowerrightfill" )
>     , ( 0x25a8, "squareupperrighttolowerleftfill" )
>     , ( 0x25a9, "squarediagonalcrosshatchfill" )
>     , ( 0x25aa, "H18543" )
>     , ( 0x25ab, "H18551" )
>     , ( 0x25ac, "blackrectangle" )
>     , ( 0x25b2, "blackuppointingtriangle" )
>     , ( 0x25b3, "whiteuppointingtriangle" )
>     , ( 0x25b4, "blackuppointingsmalltriangle" )
>     , ( 0x25b5, "whiteuppointingsmalltriangle" )
>     , ( 0x25b6, "blackrightpointingtriangle" )
>     , ( 0x25b7, "whiterightpointingtriangle" )
>     , ( 0x25b9, "whiterightpointingsmalltriangle" )
>     , ( 0x25ba, "blackrightpointingpointer" )
>     , ( 0x25bc, "blackdownpointingtriangle" )
>     , ( 0x25bd, "whitedownpointingtriangle" )
>     , ( 0x25bf, "whitedownpointingsmalltriangle" )
>     , ( 0x25c0, "blackleftpointingtriangle" )
>     , ( 0x25c1, "whiteleftpointingtriangle" )
>     , ( 0x25c3, "whiteleftpointingsmalltriangle" )
>     , ( 0x25c4, "blackleftpointingpointer" )
>     , ( 0x25c6, "blackdiamond" )
>     , ( 0x25c7, "whitediamond" )
>     , ( 0x25c8, "whitediamondcontainingblacksmalldiamond" )
>     , ( 0x25c9, "fisheye" )
>     , ( 0x25ca, "lozenge" )
>     , ( 0x25cb, "circle" )
>     , ( 0x25cc, "dottedcircle" )
>     , ( 0x25ce, "bullseye" )
>     , ( 0x25cf, "H18533" )
>     , ( 0x25d0, "circlewithlefthalfblack" )
>     , ( 0x25d1, "circlewithrighthalfblack" )
>     , ( 0x25d8, "bulletinverse" )
>     , ( 0x25d9, "invcircle" )
>     , ( 0x25e2, "blacklowerrighttriangle" )
>     , ( 0x25e3, "blacklowerlefttriangle" )
>     , ( 0x25e4, "blackupperlefttriangle" )
>     , ( 0x25e5, "blackupperrighttriangle" )
>     , ( 0x25e6, "openbullet" )
>     , ( 0x25ef, "largecircle" )
>     , ( 0x2605, "blackstar" )
>     , ( 0x2606, "whitestar" )
>     , ( 0x260e, "telephoneblack" )
>     , ( 0x260f, "whitetelephone" )
>     , ( 0x261c, "pointingindexleftwhite" )
>     , ( 0x261d, "pointingindexupwhite" )
>     , ( 0x261e, "pointingindexrightwhite" )
>     , ( 0x261f, "pointingindexdownwhite" )
>     , ( 0x262f, "yinyang" )
>     , ( 0x263a, "smileface" )
>     , ( 0x263b, "blacksmilingface" )
>     , ( 0x263c, "compass" )
>     , ( 0x2640, "female" )
>     , ( 0x2641, "earth" )
>     , ( 0x2642, "male" )
>     , ( 0x2660, "spade" )
>     , ( 0x2661, "heartsuitwhite" )
>     , ( 0x2662, "diamondsuitwhite" )
>     , ( 0x2663, "club" )
>     , ( 0x2664, "spadesuitwhite" )
>     , ( 0x2665, "heart" )
>     , ( 0x2666, "diamond" )
>     , ( 0x2667, "clubsuitwhite" )
>     , ( 0x2668, "hotsprings" )
>     , ( 0x2669, "quarternote" )
>     , ( 0x266a, "musicalnote" )
>     , ( 0x266b, "eighthnotebeamed" )
>     , ( 0x266c, "beamedsixteenthnotes" )
>     , ( 0x266d, "musicflatsign" )
>     , ( 0x266f, "musicsharpsign" )
>     , ( 0x2713, "checkmark" )
>     , ( 0x278a, "onecircleinversesansserif" )
>     , ( 0x278b, "twocircleinversesansserif" )
>     , ( 0x278c, "threecircleinversesansserif" )
>     , ( 0x278d, "fourcircleinversesansserif" )
>     , ( 0x278e, "fivecircleinversesansserif" )
>     , ( 0x278f, "sixcircleinversesansserif" )
>     , ( 0x2790, "sevencircleinversesansserif" )
>     , ( 0x2791, "eightcircleinversesansserif" )
>     , ( 0x2792, "ninecircleinversesansserif" )
>     , ( 0x279e, "arrowrightheavy" )
>     , ( 0x3000, "ideographicspace" )
>     , ( 0x3001, "ideographiccomma" )
>     , ( 0x3002, "ideographicperiod" )
>     , ( 0x3003, "dittomark" )
>     , ( 0x3004, "jis" )
>     , ( 0x3005, "ideographiciterationmark" )
>     , ( 0x3006, "ideographicclose" )
>     , ( 0x3007, "ideographiczero" )
>     , ( 0x3008, "anglebracketleft" )
>     , ( 0x3009, "anglebracketright" )
>     , ( 0x300a, "dblanglebracketleft" )
>     , ( 0x300b, "dblanglebracketright" )
>     , ( 0x300c, "cornerbracketleft" )
>     , ( 0x300d, "cornerbracketright" )
>     , ( 0x300e, "whitecornerbracketleft" )
>     , ( 0x300f, "whitecornerbracketright" )
>     , ( 0x3010, "blacklenticularbracketleft" )
>     , ( 0x3011, "blacklenticularbracketright" )
>     , ( 0x3012, "postalmark" )
>     , ( 0x3013, "getamark" )
>     , ( 0x3014, "tortoiseshellbracketleft" )
>     , ( 0x3015, "tortoiseshellbracketright" )
>     , ( 0x3016, "whitelenticularbracketleft" )
>     , ( 0x3017, "whitelenticularbracketright" )
>     , ( 0x3018, "whitetortoiseshellbracketleft" )
>     , ( 0x3019, "whitetortoiseshellbracketright" )
>     , ( 0x301c, "wavedash" )
>     , ( 0x301d, "quotedblprimereversed" )
>     , ( 0x301e, "quotedblprime" )
>     , ( 0x3020, "postalmarkface" )
>     , ( 0x3021, "onehangzhou" )
>     , ( 0x3022, "twohangzhou" )
>     , ( 0x3023, "threehangzhou" )
>     , ( 0x3024, "fourhangzhou" )
>     , ( 0x3025, "fivehangzhou" )
>     , ( 0x3026, "sixhangzhou" )
>     , ( 0x3027, "sevenhangzhou" )
>     , ( 0x3028, "eighthangzhou" )
>     , ( 0x3029, "ninehangzhou" )
>     , ( 0x3036, "circlepostalmark" )
>     , ( 0x3041, "asmallhiragana" )
>     , ( 0x3042, "ahiragana" )
>     , ( 0x3043, "ismallhiragana" )
>     , ( 0x3044, "ihiragana" )
>     , ( 0x3045, "usmallhiragana" )
>     , ( 0x3046, "uhiragana" )
>     , ( 0x3047, "esmallhiragana" )
>     , ( 0x3048, "ehiragana" )
>     , ( 0x3049, "osmallhiragana" )
>     , ( 0x304a, "ohiragana" )
>     , ( 0x304b, "kahiragana" )
>     , ( 0x304c, "gahiragana" )
>     , ( 0x304d, "kihiragana" )
>     , ( 0x304e, "gihiragana" )
>     , ( 0x304f, "kuhiragana" )
>     , ( 0x3050, "guhiragana" )
>     , ( 0x3051, "kehiragana" )
>     , ( 0x3052, "gehiragana" )
>     , ( 0x3053, "kohiragana" )
>     , ( 0x3054, "gohiragana" )
>     , ( 0x3055, "sahiragana" )
>     , ( 0x3056, "zahiragana" )
>     , ( 0x3057, "sihiragana" )
>     , ( 0x3058, "zihiragana" )
>     , ( 0x3059, "suhiragana" )
>     , ( 0x305a, "zuhiragana" )
>     , ( 0x305b, "sehiragana" )
>     , ( 0x305c, "zehiragana" )
>     , ( 0x305d, "sohiragana" )
>     , ( 0x305e, "zohiragana" )
>     , ( 0x305f, "tahiragana" )
>     , ( 0x3060, "dahiragana" )
>     , ( 0x3061, "tihiragana" )
>     , ( 0x3062, "dihiragana" )
>     , ( 0x3063, "tusmallhiragana" )
>     , ( 0x3064, "tuhiragana" )
>     , ( 0x3065, "duhiragana" )
>     , ( 0x3066, "tehiragana" )
>     , ( 0x3067, "dehiragana" )
>     , ( 0x3068, "tohiragana" )
>     , ( 0x3069, "dohiragana" )
>     , ( 0x306a, "nahiragana" )
>     , ( 0x306b, "nihiragana" )
>     , ( 0x306c, "nuhiragana" )
>     , ( 0x306d, "nehiragana" )
>     , ( 0x306e, "nohiragana" )
>     , ( 0x306f, "hahiragana" )
>     , ( 0x3070, "bahiragana" )
>     , ( 0x3071, "pahiragana" )
>     , ( 0x3072, "hihiragana" )
>     , ( 0x3073, "bihiragana" )
>     , ( 0x3074, "pihiragana" )
>     , ( 0x3075, "huhiragana" )
>     , ( 0x3076, "buhiragana" )
>     , ( 0x3077, "puhiragana" )
>     , ( 0x3078, "hehiragana" )
>     , ( 0x3079, "behiragana" )
>     , ( 0x307a, "pehiragana" )
>     , ( 0x307b, "hohiragana" )
>     , ( 0x307c, "bohiragana" )
>     , ( 0x307d, "pohiragana" )
>     , ( 0x307e, "mahiragana" )
>     , ( 0x307f, "mihiragana" )
>     , ( 0x3080, "muhiragana" )
>     , ( 0x3081, "mehiragana" )
>     , ( 0x3082, "mohiragana" )
>     , ( 0x3083, "yasmallhiragana" )
>     , ( 0x3084, "yahiragana" )
>     , ( 0x3085, "yusmallhiragana" )
>     , ( 0x3086, "yuhiragana" )
>     , ( 0x3087, "yosmallhiragana" )
>     , ( 0x3088, "yohiragana" )
>     , ( 0x3089, "rahiragana" )
>     , ( 0x308a, "rihiragana" )
>     , ( 0x308b, "ruhiragana" )
>     , ( 0x308c, "rehiragana" )
>     , ( 0x308d, "rohiragana" )
>     , ( 0x308e, "wasmallhiragana" )
>     , ( 0x308f, "wahiragana" )
>     , ( 0x3090, "wihiragana" )
>     , ( 0x3091, "wehiragana" )
>     , ( 0x3092, "wohiragana" )
>     , ( 0x3093, "nhiragana" )
>     , ( 0x3094, "vuhiragana" )
>     , ( 0x309b, "voicedmarkkana" )
>     , ( 0x309c, "semivoicedmarkkana" )
>     , ( 0x309d, "iterationhiragana" )
>     , ( 0x309e, "voicediterationhiragana" )
>     , ( 0x30a1, "asmallkatakana" )
>     , ( 0x30a2, "akatakana" )
>     , ( 0x30a3, "ismallkatakana" )
>     , ( 0x30a4, "ikatakana" )
>     , ( 0x30a5, "usmallkatakana" )
>     , ( 0x30a6, "ukatakana" )
>     , ( 0x30a7, "esmallkatakana" )
>     , ( 0x30a8, "ekatakana" )
>     , ( 0x30a9, "osmallkatakana" )
>     , ( 0x30aa, "okatakana" )
>     , ( 0x30ab, "kakatakana" )
>     , ( 0x30ac, "gakatakana" )
>     , ( 0x30ad, "kikatakana" )
>     , ( 0x30ae, "gikatakana" )
>     , ( 0x30af, "kukatakana" )
>     , ( 0x30b0, "gukatakana" )
>     , ( 0x30b1, "kekatakana" )
>     , ( 0x30b2, "gekatakana" )
>     , ( 0x30b3, "kokatakana" )
>     , ( 0x30b4, "gokatakana" )
>     , ( 0x30b5, "sakatakana" )
>     , ( 0x30b6, "zakatakana" )
>     , ( 0x30b7, "sikatakana" )
>     , ( 0x30b8, "zikatakana" )
>     , ( 0x30b9, "sukatakana" )
>     , ( 0x30ba, "zukatakana" )
>     , ( 0x30bb, "sekatakana" )
>     , ( 0x30bc, "zekatakana" )
>     , ( 0x30bd, "sokatakana" )
>     , ( 0x30be, "zokatakana" )
>     , ( 0x30bf, "takatakana" )
>     , ( 0x30c0, "dakatakana" )
>     , ( 0x30c1, "tikatakana" )
>     , ( 0x30c2, "dikatakana" )
>     , ( 0x30c3, "tusmallkatakana" )
>     , ( 0x30c4, "tukatakana" )
>     , ( 0x30c5, "dukatakana" )
>     , ( 0x30c6, "tekatakana" )
>     , ( 0x30c7, "dekatakana" )
>     , ( 0x30c8, "tokatakana" )
>     , ( 0x30c9, "dokatakana" )
>     , ( 0x30ca, "nakatakana" )
>     , ( 0x30cb, "nikatakana" )
>     , ( 0x30cc, "nukatakana" )
>     , ( 0x30cd, "nekatakana" )
>     , ( 0x30ce, "nokatakana" )
>     , ( 0x30cf, "hakatakana" )
>     , ( 0x30d0, "bakatakana" )
>     , ( 0x30d1, "pakatakana" )
>     , ( 0x30d2, "hikatakana" )
>     , ( 0x30d3, "bikatakana" )
>     , ( 0x30d4, "pikatakana" )
>     , ( 0x30d5, "hukatakana" )
>     , ( 0x30d6, "bukatakana" )
>     , ( 0x30d7, "pukatakana" )
>     , ( 0x30d8, "hekatakana" )
>     , ( 0x30d9, "bekatakana" )
>     , ( 0x30da, "pekatakana" )
>     , ( 0x30db, "hokatakana" )
>     , ( 0x30dc, "bokatakana" )
>     , ( 0x30dd, "pokatakana" )
>     , ( 0x30de, "makatakana" )
>     , ( 0x30df, "mikatakana" )
>     , ( 0x30e0, "mukatakana" )
>     , ( 0x30e1, "mekatakana" )
>     , ( 0x30e2, "mokatakana" )
>     , ( 0x30e3, "yasmallkatakana" )
>     , ( 0x30e4, "yakatakana" )
>     , ( 0x30e5, "yusmallkatakana" )
>     , ( 0x30e6, "yukatakana" )
>     , ( 0x30e7, "yosmallkatakana" )
>     , ( 0x30e8, "yokatakana" )
>     , ( 0x30e9, "rakatakana" )
>     , ( 0x30ea, "rikatakana" )
>     , ( 0x30eb, "rukatakana" )
>     , ( 0x30ec, "rekatakana" )
>     , ( 0x30ed, "rokatakana" )
>     , ( 0x30ee, "wasmallkatakana" )
>     , ( 0x30ef, "wakatakana" )
>     , ( 0x30f0, "wikatakana" )
>     , ( 0x30f1, "wekatakana" )
>     , ( 0x30f2, "wokatakana" )
>     , ( 0x30f3, "nkatakana" )
>     , ( 0x30f4, "vukatakana" )
>     , ( 0x30f5, "kasmallkatakana" )
>     , ( 0x30f6, "kesmallkatakana" )
>     , ( 0x30f7, "vakatakana" )
>     , ( 0x30f8, "vikatakana" )
>     , ( 0x30f9, "vekatakana" )
>     , ( 0x30fa, "vokatakana" )
>     , ( 0x30fb, "dotkatakana" )
>     , ( 0x30fc, "prolongedkana" )
>     , ( 0x30fd, "iterationkatakana" )
>     , ( 0x30fe, "voicediterationkatakana" )
>     , ( 0x3105, "bbopomofo" )
>     , ( 0x3106, "pbopomofo" )
>     , ( 0x3107, "mbopomofo" )
>     , ( 0x3108, "fbopomofo" )
>     , ( 0x3109, "dbopomofo" )
>     , ( 0x310a, "tbopomofo" )
>     , ( 0x310b, "nbopomofo" )
>     , ( 0x310c, "lbopomofo" )
>     , ( 0x310d, "gbopomofo" )
>     , ( 0x310e, "kbopomofo" )
>     , ( 0x310f, "hbopomofo" )
>     , ( 0x3110, "jbopomofo" )
>     , ( 0x3111, "qbopomofo" )
>     , ( 0x3112, "xbopomofo" )
>     , ( 0x3113, "zhbopomofo" )
>     , ( 0x3114, "chbopomofo" )
>     , ( 0x3115, "shbopomofo" )
>     , ( 0x3116, "rbopomofo" )
>     , ( 0x3117, "zbopomofo" )
>     , ( 0x3118, "cbopomofo" )
>     , ( 0x3119, "sbopomofo" )
>     , ( 0x311a, "abopomofo" )
>     , ( 0x311b, "obopomofo" )
>     , ( 0x311c, "ebopomofo" )
>     , ( 0x311d, "ehbopomofo" )
>     , ( 0x311e, "aibopomofo" )
>     , ( 0x311f, "eibopomofo" )
>     , ( 0x3120, "aubopomofo" )
>     , ( 0x3121, "oubopomofo" )
>     , ( 0x3122, "anbopomofo" )
>     , ( 0x3123, "enbopomofo" )
>     , ( 0x3124, "angbopomofo" )
>     , ( 0x3125, "engbopomofo" )
>     , ( 0x3126, "erbopomofo" )
>     , ( 0x3127, "ibopomofo" )
>     , ( 0x3128, "ubopomofo" )
>     , ( 0x3129, "iubopomofo" )
>     , ( 0x3131, "kiyeokkorean" )
>     , ( 0x3132, "ssangkiyeokkorean" )
>     , ( 0x3133, "kiyeoksioskorean" )
>     , ( 0x3134, "nieunkorean" )
>     , ( 0x3135, "nieuncieuckorean" )
>     , ( 0x3136, "nieunhieuhkorean" )
>     , ( 0x3137, "tikeutkorean" )
>     , ( 0x3138, "ssangtikeutkorean" )
>     , ( 0x3139, "rieulkorean" )
>     , ( 0x313a, "rieulkiyeokkorean" )
>     , ( 0x313b, "rieulmieumkorean" )
>     , ( 0x313c, "rieulpieupkorean" )
>     , ( 0x313d, "rieulsioskorean" )
>     , ( 0x313e, "rieulthieuthkorean" )
>     , ( 0x313f, "rieulphieuphkorean" )
>     , ( 0x3140, "rieulhieuhkorean" )
>     , ( 0x3141, "mieumkorean" )
>     , ( 0x3142, "pieupkorean" )
>     , ( 0x3143, "ssangpieupkorean" )
>     , ( 0x3144, "pieupsioskorean" )
>     , ( 0x3145, "sioskorean" )
>     , ( 0x3146, "ssangsioskorean" )
>     , ( 0x3147, "ieungkorean" )
>     , ( 0x3148, "cieuckorean" )
>     , ( 0x3149, "ssangcieuckorean" )
>     , ( 0x314a, "chieuchkorean" )
>     , ( 0x314b, "khieukhkorean" )
>     , ( 0x314c, "thieuthkorean" )
>     , ( 0x314d, "phieuphkorean" )
>     , ( 0x314e, "hieuhkorean" )
>     , ( 0x314f, "akorean" )
>     , ( 0x3150, "aekorean" )
>     , ( 0x3151, "yakorean" )
>     , ( 0x3152, "yaekorean" )
>     , ( 0x3153, "eokorean" )
>     , ( 0x3154, "ekorean" )
>     , ( 0x3155, "yeokorean" )
>     , ( 0x3156, "yekorean" )
>     , ( 0x3157, "okorean" )
>     , ( 0x3158, "wakorean" )
>     , ( 0x3159, "waekorean" )
>     , ( 0x315a, "oekorean" )
>     , ( 0x315b, "yokorean" )
>     , ( 0x315c, "ukorean" )
>     , ( 0x315d, "weokorean" )
>     , ( 0x315e, "wekorean" )
>     , ( 0x315f, "wikorean" )
>     , ( 0x3160, "yukorean" )
>     , ( 0x3161, "eukorean" )
>     , ( 0x3162, "yikorean" )
>     , ( 0x3163, "ikorean" )
>     , ( 0x3164, "hangulfiller" )
>     , ( 0x3165, "ssangnieunkorean" )
>     , ( 0x3166, "nieuntikeutkorean" )
>     , ( 0x3167, "nieunsioskorean" )
>     , ( 0x3168, "nieunpansioskorean" )
>     , ( 0x3169, "rieulkiyeoksioskorean" )
>     , ( 0x316a, "rieultikeutkorean" )
>     , ( 0x316b, "rieulpieupsioskorean" )
>     , ( 0x316c, "rieulpansioskorean" )
>     , ( 0x316d, "rieulyeorinhieuhkorean" )
>     , ( 0x316e, "mieumpieupkorean" )
>     , ( 0x316f, "mieumsioskorean" )
>     , ( 0x3170, "mieumpansioskorean" )
>     , ( 0x3171, "kapyeounmieumkorean" )
>     , ( 0x3172, "pieupkiyeokkorean" )
>     , ( 0x3173, "pieuptikeutkorean" )
>     , ( 0x3174, "pieupsioskiyeokkorean" )
>     , ( 0x3175, "pieupsiostikeutkorean" )
>     , ( 0x3176, "pieupcieuckorean" )
>     , ( 0x3177, "pieupthieuthkorean" )
>     , ( 0x3178, "kapyeounpieupkorean" )
>     , ( 0x3179, "kapyeounssangpieupkorean" )
>     , ( 0x317a, "sioskiyeokkorean" )
>     , ( 0x317b, "siosnieunkorean" )
>     , ( 0x317c, "siostikeutkorean" )
>     , ( 0x317d, "siospieupkorean" )
>     , ( 0x317e, "sioscieuckorean" )
>     , ( 0x317f, "pansioskorean" )
>     , ( 0x3180, "ssangieungkorean" )
>     , ( 0x3181, "yesieungkorean" )
>     , ( 0x3182, "yesieungsioskorean" )
>     , ( 0x3183, "yesieungpansioskorean" )
>     , ( 0x3184, "kapyeounphieuphkorean" )
>     , ( 0x3185, "ssanghieuhkorean" )
>     , ( 0x3186, "yeorinhieuhkorean" )
>     , ( 0x3187, "yoyakorean" )
>     , ( 0x3188, "yoyaekorean" )
>     , ( 0x3189, "yoikorean" )
>     , ( 0x318a, "yuyeokorean" )
>     , ( 0x318b, "yuyekorean" )
>     , ( 0x318c, "yuikorean" )
>     , ( 0x318d, "araeakorean" )
>     , ( 0x318e, "araeaekorean" )
>     , ( 0x3200, "kiyeokparenkorean" )
>     , ( 0x3201, "nieunparenkorean" )
>     , ( 0x3202, "tikeutparenkorean" )
>     , ( 0x3203, "rieulparenkorean" )
>     , ( 0x3204, "mieumparenkorean" )
>     , ( 0x3205, "pieupparenkorean" )
>     , ( 0x3206, "siosparenkorean" )
>     , ( 0x3207, "ieungparenkorean" )
>     , ( 0x3208, "cieucparenkorean" )
>     , ( 0x3209, "chieuchparenkorean" )
>     , ( 0x320a, "khieukhparenkorean" )
>     , ( 0x320b, "thieuthparenkorean" )
>     , ( 0x320c, "phieuphparenkorean" )
>     , ( 0x320d, "hieuhparenkorean" )
>     , ( 0x320e, "kiyeokaparenkorean" )
>     , ( 0x320f, "nieunaparenkorean" )
>     , ( 0x3210, "tikeutaparenkorean" )
>     , ( 0x3211, "rieulaparenkorean" )
>     , ( 0x3212, "mieumaparenkorean" )
>     , ( 0x3213, "pieupaparenkorean" )
>     , ( 0x3214, "siosaparenkorean" )
>     , ( 0x3215, "ieungaparenkorean" )
>     , ( 0x3216, "cieucaparenkorean" )
>     , ( 0x3217, "chieuchaparenkorean" )
>     , ( 0x3218, "khieukhaparenkorean" )
>     , ( 0x3219, "thieuthaparenkorean" )
>     , ( 0x321a, "phieuphaparenkorean" )
>     , ( 0x321b, "hieuhaparenkorean" )
>     , ( 0x321c, "cieucuparenkorean" )
>     , ( 0x3220, "oneideographicparen" )
>     , ( 0x3221, "twoideographicparen" )
>     , ( 0x3222, "threeideographicparen" )
>     , ( 0x3223, "fourideographicparen" )
>     , ( 0x3224, "fiveideographicparen" )
>     , ( 0x3225, "sixideographicparen" )
>     , ( 0x3226, "sevenideographicparen" )
>     , ( 0x3227, "eightideographicparen" )
>     , ( 0x3228, "nineideographicparen" )
>     , ( 0x3229, "tenideographicparen" )
>     , ( 0x322a, "ideographicmoonparen" )
>     , ( 0x322b, "ideographicfireparen" )
>     , ( 0x322c, "ideographicwaterparen" )
>     , ( 0x322d, "ideographicwoodparen" )
>     , ( 0x322e, "ideographicmetalparen" )
>     , ( 0x322f, "ideographicearthparen" )
>     , ( 0x3230, "ideographicsunparen" )
>     , ( 0x3231, "ideographicstockparen" )
>     , ( 0x3232, "ideographichaveparen" )
>     , ( 0x3233, "ideographicsocietyparen" )
>     , ( 0x3234, "ideographicnameparen" )
>     , ( 0x3235, "ideographicspecialparen" )
>     , ( 0x3236, "ideographicfinancialparen" )
>     , ( 0x3237, "ideographiccongratulationparen" )
>     , ( 0x3238, "ideographiclaborparen" )
>     , ( 0x3239, "ideographicrepresentparen" )
>     , ( 0x323a, "ideographiccallparen" )
>     , ( 0x323b, "ideographicstudyparen" )
>     , ( 0x323c, "ideographicsuperviseparen" )
>     , ( 0x323d, "ideographicenterpriseparen" )
>     , ( 0x323e, "ideographicresourceparen" )
>     , ( 0x323f, "ideographicallianceparen" )
>     , ( 0x3240, "ideographicfestivalparen" )
>     , ( 0x3242, "ideographicselfparen" )
>     , ( 0x3243, "ideographicreachparen" )
>     , ( 0x3260, "kiyeokcirclekorean" )
>     , ( 0x3261, "nieuncirclekorean" )
>     , ( 0x3262, "tikeutcirclekorean" )
>     , ( 0x3263, "rieulcirclekorean" )
>     , ( 0x3264, "mieumcirclekorean" )
>     , ( 0x3265, "pieupcirclekorean" )
>     , ( 0x3266, "sioscirclekorean" )
>     , ( 0x3267, "ieungcirclekorean" )
>     , ( 0x3268, "cieuccirclekorean" )
>     , ( 0x3269, "chieuchcirclekorean" )
>     , ( 0x326a, "khieukhcirclekorean" )
>     , ( 0x326b, "thieuthcirclekorean" )
>     , ( 0x326c, "phieuphcirclekorean" )
>     , ( 0x326d, "hieuhcirclekorean" )
>     , ( 0x326e, "kiyeokacirclekorean" )
>     , ( 0x326f, "nieunacirclekorean" )
>     , ( 0x3270, "tikeutacirclekorean" )
>     , ( 0x3271, "rieulacirclekorean" )
>     , ( 0x3272, "mieumacirclekorean" )
>     , ( 0x3273, "pieupacirclekorean" )
>     , ( 0x3274, "siosacirclekorean" )
>     , ( 0x3275, "ieungacirclekorean" )
>     , ( 0x3276, "cieucacirclekorean" )
>     , ( 0x3277, "chieuchacirclekorean" )
>     , ( 0x3278, "khieukhacirclekorean" )
>     , ( 0x3279, "thieuthacirclekorean" )
>     , ( 0x327a, "phieuphacirclekorean" )
>     , ( 0x327b, "hieuhacirclekorean" )
>     , ( 0x327f, "koreanstandardsymbol" )
>     , ( 0x328a, "ideographmooncircle" )
>     , ( 0x328b, "ideographfirecircle" )
>     , ( 0x328c, "ideographwatercircle" )
>     , ( 0x328d, "ideographwoodcircle" )
>     , ( 0x328e, "ideographmetalcircle" )
>     , ( 0x328f, "ideographearthcircle" )
>     , ( 0x3290, "ideographsuncircle" )
>     , ( 0x3294, "ideographnamecircle" )
>     , ( 0x3296, "ideographicfinancialcircle" )
>     , ( 0x3298, "ideographiclaborcircle" )
>     , ( 0x3299, "ideographicsecretcircle" )
>     , ( 0x329d, "ideographicexcellentcircle" )
>     , ( 0x329e, "ideographicprintcircle" )
>     , ( 0x32a3, "ideographiccorrectcircle" )
>     , ( 0x32a4, "ideographichighcircle" )
>     , ( 0x32a5, "ideographiccentrecircle" )
>     , ( 0x32a6, "ideographiclowcircle" )
>     , ( 0x32a7, "ideographicleftcircle" )
>     , ( 0x32a8, "ideographicrightcircle" )
>     , ( 0x32a9, "ideographicmedicinecircle" )
>     , ( 0x3300, "apaatosquare" )
>     , ( 0x3303, "aarusquare" )
>     , ( 0x3305, "intisquare" )
>     , ( 0x330d, "karoriisquare" )
>     , ( 0x3314, "kirosquare" )
>     , ( 0x3315, "kiroguramusquare" )
>     , ( 0x3316, "kiromeetorusquare" )
>     , ( 0x3318, "guramusquare" )
>     , ( 0x331e, "kooposquare" )
>     , ( 0x3322, "sentisquare" )
>     , ( 0x3323, "sentosquare" )
>     , ( 0x3326, "dorusquare" )
>     , ( 0x3327, "tonsquare" )
>     , ( 0x332a, "haitusquare" )
>     , ( 0x332b, "paasentosquare" )
>     , ( 0x3331, "birusquare" )
>     , ( 0x3333, "huiitosquare" )
>     , ( 0x3336, "hekutaarusquare" )
>     , ( 0x3339, "herutusquare" )
>     , ( 0x333b, "peezisquare" )
>     , ( 0x3342, "hoonsquare" )
>     , ( 0x3347, "mansyonsquare" )
>     , ( 0x3349, "mirisquare" )
>     , ( 0x334a, "miribaarusquare" )
>     , ( 0x334d, "meetorusquare" )
>     , ( 0x334e, "yaadosquare" )
>     , ( 0x3351, "rittorusquare" )
>     , ( 0x3357, "wattosquare" )
>     , ( 0x337b, "heiseierasquare" )
>     , ( 0x337c, "syouwaerasquare" )
>     , ( 0x337d, "taisyouerasquare" )
>     , ( 0x337e, "meizierasquare" )
>     , ( 0x337f, "corporationsquare" )
>     , ( 0x3380, "paampssquare" )
>     , ( 0x3381, "nasquare" )
>     , ( 0x3382, "muasquare" )
>     , ( 0x3383, "masquare" )
>     , ( 0x3384, "kasquare" )
>     , ( 0x3385, "KBsquare" )
>     , ( 0x3386, "MBsquare" )
>     , ( 0x3387, "GBsquare" )
>     , ( 0x3388, "calsquare" )
>     , ( 0x3389, "kcalsquare" )
>     , ( 0x338a, "pfsquare" )
>     , ( 0x338b, "nfsquare" )
>     , ( 0x338c, "mufsquare" )
>     , ( 0x338d, "mugsquare" )
>     , ( 0x338e, "squaremg" )
>     , ( 0x338f, "squarekg" )
>     , ( 0x3390, "Hzsquare" )
>     , ( 0x3391, "khzsquare" )
>     , ( 0x3392, "mhzsquare" )
>     , ( 0x3393, "ghzsquare" )
>     , ( 0x3394, "thzsquare" )
>     , ( 0x3395, "mulsquare" )
>     , ( 0x3396, "mlsquare" )
>     , ( 0x3397, "dlsquare" )
>     , ( 0x3398, "klsquare" )
>     , ( 0x3399, "fmsquare" )
>     , ( 0x339a, "nmsquare" )
>     , ( 0x339b, "mumsquare" )
>     , ( 0x339c, "squaremm" )
>     , ( 0x339d, "squarecm" )
>     , ( 0x339e, "squarekm" )
>     , ( 0x339f, "mmsquaredsquare" )
>     , ( 0x33a0, "cmsquaredsquare" )
>     , ( 0x33a1, "squaremsquared" )
>     , ( 0x33a2, "kmsquaredsquare" )
>     , ( 0x33a3, "mmcubedsquare" )
>     , ( 0x33a4, "cmcubedsquare" )
>     , ( 0x33a5, "mcubedsquare" )
>     , ( 0x33a6, "kmcubedsquare" )
>     , ( 0x33a7, "moverssquare" )
>     , ( 0x33a8, "moverssquaredsquare" )
>     , ( 0x33a9, "pasquare" )
>     , ( 0x33aa, "kpasquare" )
>     , ( 0x33ab, "mpasquare" )
>     , ( 0x33ac, "gpasquare" )
>     , ( 0x33ad, "radsquare" )
>     , ( 0x33ae, "radoverssquare" )
>     , ( 0x33af, "radoverssquaredsquare" )
>     , ( 0x33b0, "pssquare" )
>     , ( 0x33b1, "nssquare" )
>     , ( 0x33b2, "mussquare" )
>     , ( 0x33b3, "mssquare" )
>     , ( 0x33b4, "pvsquare" )
>     , ( 0x33b5, "nvsquare" )
>     , ( 0x33b6, "muvsquare" )
>     , ( 0x33b7, "mvsquare" )
>     , ( 0x33b8, "kvsquare" )
>     , ( 0x33b9, "mvmegasquare" )
>     , ( 0x33ba, "pwsquare" )
>     , ( 0x33bb, "nwsquare" )
>     , ( 0x33bc, "muwsquare" )
>     , ( 0x33bd, "mwsquare" )
>     , ( 0x33be, "kwsquare" )
>     , ( 0x33bf, "mwmegasquare" )
>     , ( 0x33c0, "kohmsquare" )
>     , ( 0x33c1, "mohmsquare" )
>     , ( 0x33c2, "amsquare" )
>     , ( 0x33c3, "bqsquare" )
>     , ( 0x33c4, "squarecc" )
>     , ( 0x33c5, "cdsquare" )
>     , ( 0x33c6, "coverkgsquare" )
>     , ( 0x33c7, "cosquare" )
>     , ( 0x33c8, "dbsquare" )
>     , ( 0x33c9, "gysquare" )
>     , ( 0x33ca, "hasquare" )
>     , ( 0x33cb, "HPsquare" )
>     , ( 0x33cd, "KKsquare" )
>     , ( 0x33ce, "squarekmcapital" )
>     , ( 0x33cf, "ktsquare" )
>     , ( 0x33d0, "lmsquare" )
>     , ( 0x33d1, "squareln" )
>     , ( 0x33d2, "squarelog" )
>     , ( 0x33d3, "lxsquare" )
>     , ( 0x33d4, "mbsquare" )
>     , ( 0x33d5, "squaremil" )
>     , ( 0x33d6, "molsquare" )
>     , ( 0x33d8, "pmsquare" )
>     , ( 0x33db, "srsquare" )
>     , ( 0x33dc, "svsquare" )
>     , ( 0x33dd, "wbsquare" )
>     , ( 0x5344, "twentyhangzhou" )
>     , ( 0xf6be, "dotlessj" )
>     , ( 0xf6bf, "LL" )
>     , ( 0xf6c0, "ll" )
>     , ( 0xf6c3, "commaaccent" )
>     , ( 0xf6c4, "afii10063" )
>     , ( 0xf6c5, "afii10064" )
>     , ( 0xf6c6, "afii10192" )
>     , ( 0xf6c7, "afii10831" )
>     , ( 0xf6c8, "afii10832" )
>     , ( 0xf6c9, "Acute" )
>     , ( 0xf6ca, "Caron" )
>     , ( 0xf6cb, "Dieresis" )
>     , ( 0xf6cc, "DieresisAcute" )
>     , ( 0xf6cd, "DieresisGrave" )
>     , ( 0xf6ce, "Grave" )
>     , ( 0xf6cf, "Hungarumlaut" )
>     , ( 0xf6d0, "Macron" )
>     , ( 0xf6d1, "cyrBreve" )
>     , ( 0xf6d2, "cyrFlex" )
>     , ( 0xf6d3, "dblGrave" )
>     , ( 0xf6d4, "cyrbreve" )
>     , ( 0xf6d5, "cyrflex" )
>     , ( 0xf6d6, "dblgrave" )
>     , ( 0xf6d7, "dieresisacute" )
>     , ( 0xf6d8, "dieresisgrave" )
>     , ( 0xf6d9, "copyrightserif" )
>     , ( 0xf6da, "registerserif" )
>     , ( 0xf6db, "trademarkserif" )
>     , ( 0xf6dc, "onefitted" )
>     , ( 0xf6dd, "rupiah" )
>     , ( 0xf6de, "threequartersemdash" )
>     , ( 0xf6df, "centinferior" )
>     , ( 0xf6e0, "centsuperior" )
>     , ( 0xf6e1, "commainferior" )
>     , ( 0xf6e2, "commasuperior" )
>     , ( 0xf6e3, "dollarinferior" )
>     , ( 0xf6e4, "dollarsuperior" )
>     , ( 0xf6e5, "hypheninferior" )
>     , ( 0xf6e6, "hyphensuperior" )
>     , ( 0xf6e7, "periodinferior" )
>     , ( 0xf6e8, "periodsuperior" )
>     , ( 0xf6e9, "asuperior" )
>     , ( 0xf6ea, "bsuperior" )
>     , ( 0xf6eb, "dsuperior" )
>     , ( 0xf6ec, "esuperior" )
>     , ( 0xf6ed, "isuperior" )
>     , ( 0xf6ee, "lsuperior" )
>     , ( 0xf6ef, "msuperior" )
>     , ( 0xf6f0, "osuperior" )
>     , ( 0xf6f1, "rsuperior" )
>     , ( 0xf6f2, "ssuperior" )
>     , ( 0xf6f3, "tsuperior" )
>     , ( 0xf6f4, "Brevesmall" )
>     , ( 0xf6f5, "Caronsmall" )
>     , ( 0xf6f6, "Circumflexsmall" )
>     , ( 0xf6f7, "Dotaccentsmall" )
>     , ( 0xf6f8, "Hungarumlautsmall" )
>     , ( 0xf6f9, "Lslashsmall" )
>     , ( 0xf6fa, "OEsmall" )
>     , ( 0xf6fb, "Ogoneksmall" )
>     , ( 0xf6fc, "Ringsmall" )
>     , ( 0xf6fd, "Scaronsmall" )
>     , ( 0xf6fe, "Tildesmall" )
>     , ( 0xf6ff, "Zcaronsmall" )
>     , ( 0xf721, "exclamsmall" )
>     , ( 0xf724, "dollaroldstyle" )
>     , ( 0xf726, "ampersandsmall" )
>     , ( 0xf730, "zerooldstyle" )
>     , ( 0xf731, "oneoldstyle" )
>     , ( 0xf732, "twooldstyle" )
>     , ( 0xf733, "threeoldstyle" )
>     , ( 0xf734, "fouroldstyle" )
>     , ( 0xf735, "fiveoldstyle" )
>     , ( 0xf736, "sixoldstyle" )
>     , ( 0xf737, "sevenoldstyle" )
>     , ( 0xf738, "eightoldstyle" )
>     , ( 0xf739, "nineoldstyle" )
>     , ( 0xf73f, "questionsmall" )
>     , ( 0xf760, "Gravesmall" )
>     , ( 0xf761, "Asmall" )
>     , ( 0xf762, "Bsmall" )
>     , ( 0xf763, "Csmall" )
>     , ( 0xf764, "Dsmall" )
>     , ( 0xf765, "Esmall" )
>     , ( 0xf766, "Fsmall" )
>     , ( 0xf767, "Gsmall" )
>     , ( 0xf768, "Hsmall" )
>     , ( 0xf769, "Ismall" )
>     , ( 0xf76a, "Jsmall" )
>     , ( 0xf76b, "Ksmall" )
>     , ( 0xf76c, "Lsmall" )
>     , ( 0xf76d, "Msmall" )
>     , ( 0xf76e, "Nsmall" )
>     , ( 0xf76f, "Osmall" )
>     , ( 0xf770, "Psmall" )
>     , ( 0xf771, "Qsmall" )
>     , ( 0xf772, "Rsmall" )
>     , ( 0xf773, "Ssmall" )
>     , ( 0xf774, "Tsmall" )
>     , ( 0xf775, "Usmall" )
>     , ( 0xf776, "Vsmall" )
>     , ( 0xf777, "Wsmall" )
>     , ( 0xf778, "Xsmall" )
>     , ( 0xf779, "Ysmall" )
>     , ( 0xf77a, "Zsmall" )
>     , ( 0xf7a1, "exclamdownsmall" )
>     , ( 0xf7a2, "centoldstyle" )
>     , ( 0xf7a8, "Dieresissmall" )
>     , ( 0xf7af, "Macronsmall" )
>     , ( 0xf7b4, "Acutesmall" )
>     , ( 0xf7b8, "Cedillasmall" )
>     , ( 0xf7bf, "questiondownsmall" )
>     , ( 0xf7e0, "Agravesmall" )
>     , ( 0xf7e1, "Aacutesmall" )
>     , ( 0xf7e2, "Acircumflexsmall" )
>     , ( 0xf7e3, "Atildesmall" )
>     , ( 0xf7e4, "Adieresissmall" )
>     , ( 0xf7e5, "Aringsmall" )
>     , ( 0xf7e6, "AEsmall" )
>     , ( 0xf7e7, "Ccedillasmall" )
>     , ( 0xf7e8, "Egravesmall" )
>     , ( 0xf7e9, "Eacutesmall" )
>     , ( 0xf7ea, "Ecircumflexsmall" )
>     , ( 0xf7eb, "Edieresissmall" )
>     , ( 0xf7ec, "Igravesmall" )
>     , ( 0xf7ed, "Iacutesmall" )
>     , ( 0xf7ee, "Icircumflexsmall" )
>     , ( 0xf7ef, "Idieresissmall" )
>     , ( 0xf7f0, "Ethsmall" )
>     , ( 0xf7f1, "Ntildesmall" )
>     , ( 0xf7f2, "Ogravesmall" )
>     , ( 0xf7f3, "Oacutesmall" )
>     , ( 0xf7f4, "Ocircumflexsmall" )
>     , ( 0xf7f5, "Otildesmall" )
>     , ( 0xf7f6, "Odieresissmall" )
>     , ( 0xf7f8, "Oslashsmall" )
>     , ( 0xf7f9, "Ugravesmall" )
>     , ( 0xf7fa, "Uacutesmall" )
>     , ( 0xf7fb, "Ucircumflexsmall" )
>     , ( 0xf7fc, "Udieresissmall" )
>     , ( 0xf7fd, "Yacutesmall" )
>     , ( 0xf7fe, "Thornsmall" )
>     , ( 0xf7ff, "Ydieresissmall" )
>     , ( 0xf884, "maihanakatleftthai" )
>     , ( 0xf885, "saraileftthai" )
>     , ( 0xf886, "saraiileftthai" )
>     , ( 0xf887, "saraueleftthai" )
>     , ( 0xf888, "saraueeleftthai" )
>     , ( 0xf889, "maitaikhuleftthai" )
>     , ( 0xf88a, "maiekupperleftthai" )
>     , ( 0xf88b, "maieklowrightthai" )
>     , ( 0xf88c, "maieklowleftthai" )
>     , ( 0xf88d, "maithoupperleftthai" )
>     , ( 0xf88e, "maitholowrightthai" )
>     , ( 0xf88f, "maitholowleftthai" )
>     , ( 0xf890, "maitriupperleftthai" )
>     , ( 0xf891, "maitrilowrightthai" )
>     , ( 0xf892, "maitrilowleftthai" )
>     , ( 0xf893, "maichattawaupperleftthai" )
>     , ( 0xf894, "maichattawalowrightthai" )
>     , ( 0xf895, "maichattawalowleftthai" )
>     , ( 0xf896, "thanthakhatupperleftthai" )
>     , ( 0xf897, "thanthakhatlowrightthai" )
>     , ( 0xf898, "thanthakhatlowleftthai" )
>     , ( 0xf899, "nikhahitleftthai" )
>     , ( 0xf8e5, "radicalex" )
>     , ( 0xf8e6, "arrowvertex" )
>     , ( 0xf8e7, "arrowhorizex" )
>     , ( 0xf8e8, "registersans" )
>     , ( 0xf8e9, "copyrightsans" )
>     , ( 0xf8ea, "trademarksans" )
>     , ( 0xf8eb, "parenlefttp" )
>     , ( 0xf8ec, "parenleftex" )
>     , ( 0xf8ed, "parenleftbt" )
>     , ( 0xf8ee, "bracketlefttp" )
>     , ( 0xf8ef, "bracketleftex" )
>     , ( 0xf8f0, "bracketleftbt" )
>     , ( 0xf8f1, "bracelefttp" )
>     , ( 0xf8f2, "braceleftmid" )
>     , ( 0xf8f3, "braceleftbt" )
>     , ( 0xf8f4, "braceex" )
>     , ( 0xf8f5, "integralex" )
>     , ( 0xf8f6, "parenrighttp" )
>     , ( 0xf8f7, "parenrightex" )
>     , ( 0xf8f8, "parenrightbt" )
>     , ( 0xf8f9, "bracketrighttp" )
>     , ( 0xf8fa, "bracketrightex" )
>     , ( 0xf8fb, "bracketrightbt" )
>     , ( 0xf8fc, "bracerighttp" )
>     , ( 0xf8fd, "bracerightmid" )
>     , ( 0xf8fe, "bracerightbt" )
>     , ( 0xf8ff, "apple" )
>     , ( 0xfb00, "ff" )
>     , ( 0xfb01, "fi" )
>     , ( 0xfb02, "fl" )
>     , ( 0xfb03, "ffi" )
>     , ( 0xfb04, "ffl" )
>     , ( 0xfb1f, "afii57705" )
>     , ( 0xfb20, "ayinaltonehebrew" )
>     , ( 0xfb2a, "afii57694" )
>     , ( 0xfb2b, "afii57695" )
>     , ( 0xfb2c, "shindageshshindot" )
>     , ( 0xfb2d, "shindageshsindot" )
>     , ( 0xfb2e, "alefpatahhebrew" )
>     , ( 0xfb2f, "alefqamatshebrew" )
>     , ( 0xfb30, "alefdageshhebrew" )
>     , ( 0xfb31, "betdagesh" )
>     , ( 0xfb32, "gimeldagesh" )
>     , ( 0xfb33, "daletdagesh" )
>     , ( 0xfb34, "hedagesh" )
>     , ( 0xfb35, "afii57723" )
>     , ( 0xfb36, "zayindagesh" )
>     , ( 0xfb38, "tetdagesh" )
>     , ( 0xfb39, "yoddagesh" )
>     , ( 0xfb3a, "finalkafdagesh" )
>     , ( 0xfb3b, "kafdagesh" )
>     , ( 0xfb3c, "lameddagesh" )
>     , ( 0xfb3e, "memdagesh" )
>     , ( 0xfb40, "nundagesh" )
>     , ( 0xfb41, "samekhdagesh" )
>     , ( 0xfb43, "pefinaldageshhebrew" )
>     , ( 0xfb44, "pedagesh" )
>     , ( 0xfb46, "tsadidagesh" )
>     , ( 0xfb47, "qofdagesh" )
>     , ( 0xfb48, "reshdageshhebrew" )
>     , ( 0xfb49, "shindagesh" )
>     , ( 0xfb4a, "tavdages" )
>     , ( 0xfb4b, "afii57700" )
>     , ( 0xfb4c, "betrafehebrew" )
>     , ( 0xfb4d, "kafrafehebrew" )
>     , ( 0xfb4e, "perafehebrew" )
>     , ( 0xfb4f, "aleflamedhebrew" )
>     , ( 0xfb57, "pehfinalarabic" )
>     , ( 0xfb58, "pehinitialarabic" )
>     , ( 0xfb59, "pehmedialarabic" )
>     , ( 0xfb67, "ttehfinalarabic" )
>     , ( 0xfb68, "ttehinitialarabic" )
>     , ( 0xfb69, "ttehmedialarabic" )
>     , ( 0xfb6b, "vehfinalarabic" )
>     , ( 0xfb6c, "vehinitialarabic" )
>     , ( 0xfb6d, "vehmedialarabic" )
>     , ( 0xfb7b, "tchehfinalarabic" )
>     , ( 0xfb7c, "tchehinitialarabic" )
>     , ( 0xfb7d, "tchehmedialarabic" )
>     , ( 0xfb89, "ddalfinalarabic" )
>     , ( 0xfb8b, "jehfinalarabic" )
>     , ( 0xfb8d, "rrehfinalarabic" )
>     , ( 0xfb93, "gaffinalarabic" )
>     , ( 0xfb94, "gafinitialarabic" )
>     , ( 0xfb95, "gafmedialarabic" )
>     , ( 0xfb9f, "noonghunnafinalarabic" )
>     , ( 0xfba4, "hehhamzaaboveisolatedarabic" )
>     , ( 0xfba5, "hehhamzaabovefinalarabic" )
>     , ( 0xfba7, "hehfinalaltonearabic" )
>     , ( 0xfba8, "hehinitialaltonearabic" )
>     , ( 0xfba9, "hehmedialaltonearabic" )
>     , ( 0xfbaf, "yehbarreefinalarabic" )
>     , ( 0xfc08, "behmeemisolatedarabic" )
>     , ( 0xfc0b, "tehjeemisolatedarabic" )
>     , ( 0xfc0c, "tehhahisolatedarabic" )
>     , ( 0xfc0e, "tehmeemisolatedarabic" )
>     , ( 0xfc48, "meemmeemisolatedarabic" )
>     , ( 0xfc4b, "noonjeemisolatedarabic" )
>     , ( 0xfc4e, "noonmeemisolatedarabic" )
>     , ( 0xfc58, "yehmeemisolatedarabic" )
>     , ( 0xfc5e, "shaddadammatanarabic" )
>     , ( 0xfc5f, "shaddakasratanarabic" )
>     , ( 0xfc60, "shaddafathaarabic" )
>     , ( 0xfc61, "shaddadammaarabic" )
>     , ( 0xfc62, "shaddakasraarabic" )
>     , ( 0xfc6d, "behnoonfinalarabic" )
>     , ( 0xfc73, "tehnoonfinalarabic" )
>     , ( 0xfc8d, "noonnoonfinalarabic" )
>     , ( 0xfc94, "yehnoonfinalarabic" )
>     , ( 0xfc9f, "behmeeminitialarabic" )
>     , ( 0xfca1, "tehjeeminitialarabic" )
>     , ( 0xfca2, "tehhahinitialarabic" )
>     , ( 0xfca4, "tehmeeminitialarabic" )
>     , ( 0xfcc9, "lamjeeminitialarabic" )
>     , ( 0xfcca, "lamhahinitialarabic" )
>     , ( 0xfccb, "lamkhahinitialarabic" )
>     , ( 0xfccc, "lammeeminitialarabic" )
>     , ( 0xfcd1, "meemmeeminitialarabic" )
>     , ( 0xfcd2, "noonjeeminitialarabic" )
>     , ( 0xfcd5, "noonmeeminitialarabic" )
>     , ( 0xfcdd, "yehmeeminitialarabic" )
>     , ( 0xfd3e, "parenleftaltonearabic" )
>     , ( 0xfd3f, "parenrightaltonearabic" )
>     , ( 0xfd88, "lammeemhahinitialarabic" )
>     , ( 0xfdf2, "lamlamhehisolatedarabic" )
>     , ( 0xfdfa, "sallallahoualayhewasallamarabic" )
>     , ( 0xfe30, "twodotleadervertical" )
>     , ( 0xfe31, "emdashvertical" )
>     , ( 0xfe32, "endashvertical" )
>     , ( 0xfe33, "underscorevertical" )
>     , ( 0xfe34, "wavyunderscorevertical" )
>     , ( 0xfe35, "parenleftvertical" )
>     , ( 0xfe36, "parenrightvertical" )
>     , ( 0xfe37, "braceleftvertical" )
>     , ( 0xfe38, "bracerightvertical" )
>     , ( 0xfe39, "tortoiseshellbracketleftvertical" )
>     , ( 0xfe3a, "tortoiseshellbracketrightvertical" )
>     , ( 0xfe3b, "blacklenticularbracketleftvertical" )
>     , ( 0xfe3c, "blacklenticularbracketrightvertical" )
>     , ( 0xfe3d, "dblanglebracketleftvertical" )
>     , ( 0xfe3e, "dblanglebracketrightvertical" )
>     , ( 0xfe3f, "anglebracketleftvertical" )
>     , ( 0xfe40, "anglebracketrightvertical" )
>     , ( 0xfe41, "cornerbracketleftvertical" )
>     , ( 0xfe42, "cornerbracketrightvertical" )
>     , ( 0xfe43, "whitecornerbracketleftvertical" )
>     , ( 0xfe44, "whitecornerbracketrightvertical" )
>     , ( 0xfe49, "overlinedashed" )
>     , ( 0xfe4a, "overlinecenterline" )
>     , ( 0xfe4b, "overlinewavy" )
>     , ( 0xfe4c, "overlinedblwavy" )
>     , ( 0xfe4d, "lowlinedashed" )
>     , ( 0xfe4e, "lowlinecenterline" )
>     , ( 0xfe4f, "underscorewavy" )
>     , ( 0xfe50, "commasmall" )
>     , ( 0xfe52, "periodsmall" )
>     , ( 0xfe54, "semicolonsmall" )
>     , ( 0xfe55, "colonsmall" )
>     , ( 0xfe59, "parenleftsmall" )
>     , ( 0xfe5a, "parenrightsmall" )
>     , ( 0xfe5b, "braceleftsmall" )
>     , ( 0xfe5c, "bracerightsmall" )
>     , ( 0xfe5d, "tortoiseshellbracketleftsmall" )
>     , ( 0xfe5e, "tortoiseshellbracketrightsmall" )
>     , ( 0xfe5f, "numbersignsmall" )
>     , ( 0xfe61, "asterisksmall" )
>     , ( 0xfe62, "plussmall" )
>     , ( 0xfe63, "hyphensmall" )
>     , ( 0xfe64, "lesssmall" )
>     , ( 0xfe65, "greatersmall" )
>     , ( 0xfe66, "equalsmall" )
>     , ( 0xfe69, "dollarsmall" )
>     , ( 0xfe6a, "percentsmall" )
>     , ( 0xfe6b, "atsmall" )
>     , ( 0xfe82, "alefmaddaabovefinalarabic" )
>     , ( 0xfe84, "alefhamzaabovefinalarabic" )
>     , ( 0xfe86, "wawhamzaabovefinalarabic" )
>     , ( 0xfe88, "alefhamzabelowfinalarabic" )
>     , ( 0xfe8a, "yehhamzaabovefinalarabic" )
>     , ( 0xfe8b, "yehhamzaaboveinitialarabic" )
>     , ( 0xfe8c, "yehhamzaabovemedialarabic" )
>     , ( 0xfe8e, "aleffinalarabic" )
>     , ( 0xfe90, "behfinalarabic" )
>     , ( 0xfe91, "behinitialarabic" )
>     , ( 0xfe92, "behmedialarabic" )
>     , ( 0xfe94, "tehmarbutafinalarabic" )
>     , ( 0xfe96, "tehfinalarabic" )
>     , ( 0xfe97, "tehinitialarabic" )
>     , ( 0xfe98, "tehmedialarabic" )
>     , ( 0xfe9a, "thehfinalarabic" )
>     , ( 0xfe9b, "thehinitialarabic" )
>     , ( 0xfe9c, "thehmedialarabic" )
>     , ( 0xfe9e, "jeemfinalarabic" )
>     , ( 0xfe9f, "jeeminitialarabic" )
>     , ( 0xfea0, "jeemmedialarabic" )
>     , ( 0xfea2, "hahfinalarabic" )
>     , ( 0xfea3, "hahinitialarabic" )
>     , ( 0xfea4, "hahmedialarabic" )
>     , ( 0xfea6, "khahfinalarabic" )
>     , ( 0xfea7, "khahinitialarabic" )
>     , ( 0xfea8, "khahmedialarabic" )
>     , ( 0xfeaa, "dalfinalarabic" )
>     , ( 0xfeac, "thalfinalarabic" )
>     , ( 0xfeae, "rehfinalarabic" )
>     , ( 0xfeb0, "zainfinalarabic" )
>     , ( 0xfeb2, "seenfinalarabic" )
>     , ( 0xfeb3, "seeninitialarabic" )
>     , ( 0xfeb4, "seenmedialarabic" )
>     , ( 0xfeb6, "sheenfinalarabic" )
>     , ( 0xfeb7, "sheeninitialarabic" )
>     , ( 0xfeb8, "sheenmedialarabic" )
>     , ( 0xfeba, "sadfinalarabic" )
>     , ( 0xfebb, "sadinitialarabic" )
>     , ( 0xfebc, "sadmedialarabic" )
>     , ( 0xfebe, "dadfinalarabic" )
>     , ( 0xfebf, "dadinitialarabic" )
>     , ( 0xfec0, "dadmedialarabic" )
>     , ( 0xfec2, "tahfinalarabic" )
>     , ( 0xfec3, "tahinitialarabic" )
>     , ( 0xfec4, "tahmedialarabic" )
>     , ( 0xfec6, "zahfinalarabic" )
>     , ( 0xfec7, "zahinitialarabic" )
>     , ( 0xfec8, "zahmedialarabic" )
>     , ( 0xfeca, "ainfinalarabic" )
>     , ( 0xfecb, "aininitialarabic" )
>     , ( 0xfecc, "ainmedialarabic" )
>     , ( 0xfece, "ghainfinalarabic" )
>     , ( 0xfecf, "ghaininitialarabic" )
>     , ( 0xfed0, "ghainmedialarabic" )
>     , ( 0xfed2, "fehfinalarabic" )
>     , ( 0xfed3, "fehinitialarabic" )
>     , ( 0xfed4, "fehmedialarabic" )
>     , ( 0xfed6, "qaffinalarabic" )
>     , ( 0xfed7, "qafinitialarabic" )
>     , ( 0xfed8, "qafmedialarabic" )
>     , ( 0xfeda, "kaffinalarabic" )
>     , ( 0xfedb, "kafinitialarabic" )
>     , ( 0xfedc, "kafmedialarabic" )
>     , ( 0xfede, "lamfinalarabic" )
>     , ( 0xfedf, "laminitialarabic" )
>     , ( 0xfee0, "lammedialarabic" )
>     , ( 0xfee2, "meemfinalarabic" )
>     , ( 0xfee3, "meeminitialarabic" )
>     , ( 0xfee4, "lammeemjeeminitialarabic" )
>     , ( 0xfee6, "noonfinalarabic" )
>     , ( 0xfee7, "noonhehinitialarabic" )
>     , ( 0xfee8, "noonmedialarabic" )
>     , ( 0xfeea, "hehfinalalttwoarabic" )
>     , ( 0xfeeb, "hehinitialarabic" )
>     , ( 0xfeec, "hehmedialarabic" )
>     , ( 0xfeee, "wawfinalarabic" )
>     , ( 0xfef0, "alefmaksurafinalarabic" )
>     , ( 0xfef2, "yehfinalarabic" )
>     , ( 0xfef3, "alefmaksurainitialarabic" )
>     , ( 0xfef4, "alefmaksuramedialarabic" )
>     , ( 0xfef5, "lamalefmaddaaboveisolatedarabic" )
>     , ( 0xfef6, "lamalefmaddaabovefinalarabic" )
>     , ( 0xfef7, "lamalefhamzaaboveisolatedarabic" )
>     , ( 0xfef8, "lamalefhamzaabovefinalarabic" )
>     , ( 0xfef9, "lamalefhamzabelowisolatedarabic" )
>     , ( 0xfefa, "lamalefhamzabelowfinalarabic" )
>     , ( 0xfefb, "lamalefisolatedarabic" )
>     , ( 0xfefc, "lamaleffinalarabic" )
>     , ( 0xfeff, "zerowidthjoiner" )
>     , ( 0xff01, "exclammonospace" )
>     , ( 0xff02, "quotedblmonospace" )
>     , ( 0xff03, "numbersignmonospace" )
>     , ( 0xff04, "dollarmonospace" )
>     , ( 0xff05, "percentmonospace" )
>     , ( 0xff06, "ampersandmonospace" )
>     , ( 0xff07, "quotesinglemonospace" )
>     , ( 0xff08, "parenleftmonospace" )
>     , ( 0xff09, "parenrightmonospace" )
>     , ( 0xff0a, "asteriskmonospace" )
>     , ( 0xff0b, "plusmonospace" )
>     , ( 0xff0c, "commamonospace" )
>     , ( 0xff0d, "hyphenmonospace" )
>     , ( 0xff0e, "periodmonospace" )
>     , ( 0xff0f, "slashmonospace" )
>     , ( 0xff10, "zeromonospace" )
>     , ( 0xff11, "onemonospace" )
>     , ( 0xff12, "twomonospace" )
>     , ( 0xff13, "threemonospace" )
>     , ( 0xff14, "fourmonospace" )
>     , ( 0xff15, "fivemonospace" )
>     , ( 0xff16, "sixmonospace" )
>     , ( 0xff17, "sevenmonospace" )
>     , ( 0xff18, "eightmonospace" )
>     , ( 0xff19, "ninemonospace" )
>     , ( 0xff1a, "colonmonospace" )
>     , ( 0xff1b, "semicolonmonospace" )
>     , ( 0xff1c, "lessmonospace" )
>     , ( 0xff1d, "equalmonospace" )
>     , ( 0xff1e, "greatermonospace" )
>     , ( 0xff1f, "questionmonospace" )
>     , ( 0xff20, "atmonospace" )
>     , ( 0xff21, "Amonospace" )
>     , ( 0xff22, "Bmonospace" )
>     , ( 0xff23, "Cmonospace" )
>     , ( 0xff24, "Dmonospace" )
>     , ( 0xff25, "Emonospace" )
>     , ( 0xff26, "Fmonospace" )
>     , ( 0xff27, "Gmonospace" )
>     , ( 0xff28, "Hmonospace" )
>     , ( 0xff29, "Imonospace" )
>     , ( 0xff2a, "Jmonospace" )
>     , ( 0xff2b, "Kmonospace" )
>     , ( 0xff2c, "Lmonospace" )
>     , ( 0xff2d, "Mmonospace" )
>     , ( 0xff2e, "Nmonospace" )
>     , ( 0xff2f, "Omonospace" )
>     , ( 0xff30, "Pmonospace" )
>     , ( 0xff31, "Qmonospace" )
>     , ( 0xff32, "Rmonospace" )
>     , ( 0xff33, "Smonospace" )
>     , ( 0xff34, "Tmonospace" )
>     , ( 0xff35, "Umonospace" )
>     , ( 0xff36, "Vmonospace" )
>     , ( 0xff37, "Wmonospace" )
>     , ( 0xff38, "Xmonospace" )
>     , ( 0xff39, "Ymonospace" )
>     , ( 0xff3a, "Zmonospace" )
>     , ( 0xff3b, "bracketleftmonospace" )
>     , ( 0xff3c, "backslashmonospace" )
>     , ( 0xff3d, "bracketrightmonospace" )
>     , ( 0xff3e, "asciicircummonospace" )
>     , ( 0xff3f, "underscoremonospace" )
>     , ( 0xff40, "gravemonospace" )
>     , ( 0xff41, "amonospace" )
>     , ( 0xff42, "bmonospace" )
>     , ( 0xff43, "cmonospace" )
>     , ( 0xff44, "dmonospace" )
>     , ( 0xff45, "emonospace" )
>     , ( 0xff46, "fmonospace" )
>     , ( 0xff47, "gmonospace" )
>     , ( 0xff48, "hmonospace" )
>     , ( 0xff49, "imonospace" )
>     , ( 0xff4a, "jmonospace" )
>     , ( 0xff4b, "kmonospace" )
>     , ( 0xff4c, "lmonospace" )
>     , ( 0xff4d, "mmonospace" )
>     , ( 0xff4e, "nmonospace" )
>     , ( 0xff4f, "omonospace" )
>     , ( 0xff50, "pmonospace" )
>     , ( 0xff51, "qmonospace" )
>     , ( 0xff52, "rmonospace" )
>     , ( 0xff53, "smonospace" )
>     , ( 0xff54, "tmonospace" )
>     , ( 0xff55, "umonospace" )
>     , ( 0xff56, "vmonospace" )
>     , ( 0xff57, "wmonospace" )
>     , ( 0xff58, "xmonospace" )
>     , ( 0xff59, "ymonospace" )
>     , ( 0xff5a, "zmonospace" )
>     , ( 0xff5b, "braceleftmonospace" )
>     , ( 0xff5c, "barmonospace" )
>     , ( 0xff5d, "bracerightmonospace" )
>     , ( 0xff5e, "asciitildemonospace" )
>     , ( 0xff61, "periodhalfwidth" )
>     , ( 0xff62, "cornerbracketlefthalfwidth" )
>     , ( 0xff63, "cornerbracketrighthalfwidth" )
>     , ( 0xff64, "ideographiccommaleft" )
>     , ( 0xff65, "middledotkatakanahalfwidth" )
>     , ( 0xff66, "wokatakanahalfwidth" )
>     , ( 0xff67, "asmallkatakanahalfwidth" )
>     , ( 0xff68, "ismallkatakanahalfwidth" )
>     , ( 0xff69, "usmallkatakanahalfwidth" )
>     , ( 0xff6a, "esmallkatakanahalfwidth" )
>     , ( 0xff6b, "osmallkatakanahalfwidth" )
>     , ( 0xff6c, "yasmallkatakanahalfwidth" )
>     , ( 0xff6d, "yusmallkatakanahalfwidth" )
>     , ( 0xff6e, "yosmallkatakanahalfwidth" )
>     , ( 0xff6f, "tusmallkatakanahalfwidth" )
>     , ( 0xff70, "katahiraprolongmarkhalfwidth" )
>     , ( 0xff71, "akatakanahalfwidth" )
>     , ( 0xff72, "ikatakanahalfwidth" )
>     , ( 0xff73, "ukatakanahalfwidth" )
>     , ( 0xff74, "ekatakanahalfwidth" )
>     , ( 0xff75, "okatakanahalfwidth" )
>     , ( 0xff76, "kakatakanahalfwidth" )
>     , ( 0xff77, "kikatakanahalfwidth" )
>     , ( 0xff78, "kukatakanahalfwidth" )
>     , ( 0xff79, "kekatakanahalfwidth" )
>     , ( 0xff7a, "kokatakanahalfwidth" )
>     , ( 0xff7b, "sakatakanahalfwidth" )
>     , ( 0xff7c, "sikatakanahalfwidth" )
>     , ( 0xff7d, "sukatakanahalfwidth" )
>     , ( 0xff7e, "sekatakanahalfwidth" )
>     , ( 0xff7f, "sokatakanahalfwidth" )
>     , ( 0xff80, "takatakanahalfwidth" )
>     , ( 0xff81, "tikatakanahalfwidth" )
>     , ( 0xff82, "tukatakanahalfwidth" )
>     , ( 0xff83, "tekatakanahalfwidth" )
>     , ( 0xff84, "tokatakanahalfwidth" )
>     , ( 0xff85, "nakatakanahalfwidth" )
>     , ( 0xff86, "nikatakanahalfwidth" )
>     , ( 0xff87, "nukatakanahalfwidth" )
>     , ( 0xff88, "nekatakanahalfwidth" )
>     , ( 0xff89, "nokatakanahalfwidth" )
>     , ( 0xff8a, "hakatakanahalfwidth" )
>     , ( 0xff8b, "hikatakanahalfwidth" )
>     , ( 0xff8c, "hukatakanahalfwidth" )
>     , ( 0xff8d, "hekatakanahalfwidth" )
>     , ( 0xff8e, "hokatakanahalfwidth" )
>     , ( 0xff8f, "makatakanahalfwidth" )
>     , ( 0xff90, "mikatakanahalfwidth" )
>     , ( 0xff91, "mukatakanahalfwidth" )
>     , ( 0xff92, "mekatakanahalfwidth" )
>     , ( 0xff93, "mokatakanahalfwidth" )
>     , ( 0xff94, "yakatakanahalfwidth" )
>     , ( 0xff95, "yukatakanahalfwidth" )
>     , ( 0xff96, "yokatakanahalfwidth" )
>     , ( 0xff97, "rakatakanahalfwidth" )
>     , ( 0xff98, "rikatakanahalfwidth" )
>     , ( 0xff99, "rukatakanahalfwidth" )
>     , ( 0xff9a, "rekatakanahalfwidth" )
>     , ( 0xff9b, "rokatakanahalfwidth" )
>     , ( 0xff9c, "wakatakanahalfwidth" )
>     , ( 0xff9d, "nkatakanahalfwidth" )
>     , ( 0xff9e, "voicedmarkkanahalfwidth" )
>     , ( 0xff9f, "semivoicedmarkkanahalfwidth" )
>     , ( 0xffe0, "centmonospace" )
>     , ( 0xffe1, "sterlingmonospace" )
>     , ( 0xffe3, "macronmonospace" )
>     , ( 0xffe5, "yenmonospace" )
>     , ( 0xffe6, "wonmonospace" )
>     ]
